unit VaxServerCOM;

Interface

uses
    Classes, ComObj,
    Vcl.OleCtrls, Vcl.ComCtrls,
    Vcl.Forms, Vcl.OleServer,
    VaxTeleServerCOMLib_TLB;

type TVaxServerCOM = class(TVaxServerSIP)

  public

  const SIP_DEFAULT_PORT = 5060;

  ///////////////////////////////////////////////////////////

  const VAX_ROUTE_TYPE_USER = 0;
  const VAX_ROUTE_TYPE_LINE = 1;
  const VAX_ROUTE_TYPE_QUEUE = 2;
  const VAX_ROUTE_TYPE_RING_GROUP = 3;
  const VAX_ROUTE_TYPE_CALL_PICKUP = 4;
  const VAX_ROUTE_TYPE_ROOM = 5;
  const VAX_ROUTE_TYPE_CALL_PARK = 6;
  const VAX_ROUTE_TYPE_STEALTH_LISTEN = 7;

  ///////////////////////////////////////////////////////////

  const VAX_PEER_TYPE_USER = 0;
  const VAX_PEER_TYPE_LINE = 1;

  ///////////////////////////////////////////////////////////

  const VAX_LINE_TYPE_UDP = 0;
  const VAX_LINE_TYPE_TCP = 1;
  const VAX_LINE_TYPE_TLS = 2;

  ///////////////////////////////////////////////////////////

  const VAX_REC_MUTE_TYPE_NONE = -1;
  const VAX_REC_MUTE_TYPE_SPEAK = 0;
  const VAX_REC_MUTE_TYPE_LISTEN = 1;
  const VAX_REC_MUTE_TYPE_BOTH = 2;

  ///////////////////////////////////////////////////////////

  const VAX_WAVE_REC_TYPE_MONO_PCM = 0;
  const VAX_WAVE_REC_TYPE_STEREO_PCM = 1;
  const VAX_WAVE_REC_TYPE_MONO_G711U = 2;
  const VAX_WAVE_REC_TYPE_STEREO_G711U = 3;
  const VAX_WAVE_REC_TYPE_MONO_G711A = 4;
  const VAX_WAVE_REC_TYPE_STEREO_G711A = 5;

  ///////////////////////////////////////////////////////////

  const VAX_CALL_CHANNEL_ZERO = 0;
  const VAX_CALL_CHANNEL_ONE = 1;

  ///////////////////////////////////////////////////////////

  const VAX_DTMF_TYPE_RFC2833 = 0;
  const VAX_DTMF_TYPE_SIP_INFO = 1;
  const VAX_DTMF_TYPE_INBAND = 2;

  const VAX_PLAY_WAVE_MODE_EXCLUSIVE = 0;
  const VAX_PLAY_WAVE_MODE_MIXED = 1;

  const VAX_CODEC_GSM610 = 0;
  const VAX_CODEC_ILBC = 1;
  const VAX_CODEC_G711A = 2;
  const VAX_CODEC_G711U = 3;
  const VAX_CODEC_G729 = 4;

  const VAX_CODEC_TOTAL_COUNT = 5;

  ///////////////////////////////////////////////////////////

  const VAX_TRANSFER_TYPE_BLIND = 0;
  const VAX_TRANSFER_TYPE_CONSULT = 1;

  const VAX_STEALTH_LISTENER_FREE = 0;
  const VAX_STEALTH_LISTENER_BUSY = 1;

  ///////////////////////////////////////////////////////////

  const VAX_CUSTOM_HEADER_REQ_ID_INVITE = 0;

  ///////////////////////////////////////////////////////////

  const VAX_QUEUE_PROCESS_MODE_RING_ALL = 0;
  const VAX_QUEUE_PROCESS_MODE_HUNT_RANDOM = 1;
  const VAX_QUEUE_PROCESS_MODE_ROUND_ROBIN = 2;
  const VAX_QUEUE_PROCESS_MODE_LEAST_ANSWERED = 3;
  const VAX_QUEUE_PROCESS_MODE_LEAST_TALK_TIME = 4;
  const VAX_QUEUE_PROCESS_MODE_LONGEST_WAITING = 5;
  const VAX_QUEUE_PROCESS_MODE_PRIORITIZED_HUNT = 6;

  const VAX_QUEUE_PROCESS_TYPE_FREE = 0;
  const VAX_QUEUE_PROCESS_TYPE_ANY = 1;

  const VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_MUSIC = 0;
  const VAX_QUEUE_PLAY_WAVE_EVENT_TYPE_RING = 1;

  const VAX_QUEUE_AGENT_AVAILABLE_STATUS = 0;
  const VAX_QUEUE_AGENT_UNAVAILABLE_STATUS = 1;

  /////////////////////////////////////////////////////////

  const VAX_RING_GROUP_PROCESS_MODE_RING_ALL = 0;
  const VAX_RING_GROUP_PROCESS_MODE_HUNT_RANDOM = 1;
  const VAX_RING_GROUP_PROCESS_MODE_ROUND_ROBIN = 2;
  const VAX_RING_GROUP_PROCESS_MODE_LEAST_ANSWERED = 3;
  const VAX_RING_GROUP_PROCESS_MODE_LEAST_TALK_TIME = 4;
  const VAX_RING_GROUP_PROCESS_MODE_LONGEST_WAITING = 5;
  const VAX_RING_GROUP_PROCESS_MODE_PRIORITIZED_HUNT = 6;

  const VAX_RING_GROUP_PROCESS_TYPE_FREE = 0;
  const VAX_RING_GROUP_PROCESS_TYPE_ANY = 1;

  const VAX_CLOSED_REASON_CODE_HANGUP = 0;
  const VAX_CLOSED_REASON_CODE_SESSION_LOST = 1;
  const VAX_CLOSED_REASON_CODE_MOVED = 2;
  const VAX_CLOSED_REASON_CODE_TRANSFERED = 3;
  const VAX_CLOSED_REASON_CODE_REJECTED = 4;
  const VAX_CLOSED_REASON_CODE_FAILED = 5;
  const VAX_CLOSED_REASON_CODE_CANCELLED = 6;
  const VAX_CLOSED_REASON_CODE_TIMEOUT = 7;
  const VAX_CLOSED_REASON_CODE_CLOSED = 8;

  /////////////////////////////////////////////////////////

  const VAX_ACCESS_PCM_TYPE_ALL_NONE = -1;
  const VAX_ACCESS_PCM_TYPE_EVENT_NONE = 0;
  const VAX_ACCESS_PCM_TYPE_EVENT_MEDIA_INBOUND = 1;
  const VAX_ACCESS_PCM_TYPE_EVENT_MEDIA_OUTBOUND = 2;
  const VAX_ACCESS_PCM_TYPE_PIPE_NONE = 3;
  const VAX_ACCESS_PCM_TYPE_PIPE_MEDIA_INBOUND = 4;
  const VAX_ACCESS_PCM_TYPE_PIPE_MEDIA_OUTBOUND = 5;
  const VAX_ACCESS_PCM_TYPE_PIPE_DUPLEX_MEDIA_INBOUND = 6;

  ////////////////////////////////////////////////////////////////

  const VAX_MEDIA_FLOW_TYPE_SEND_RECV = 0;
  const VAX_MEDIA_FLOW_TYPE_SEND_ONLY = 1;
  const VAX_MEDIA_FLOW_TYPE_RECV_ONLY = 2;
  const VAX_MEDIA_FLOW_TYPE_INACTIVE = 3;

  ////////////////////////////////////////////////////////////////

  const VAX_AUDIO_TYPE_NORMAL = 0;
  const VAX_AUDIO_TYPE_USER = 1;
  const VAX_AUDIO_TYPE_ADMIN = 2;

  const VAX_VIDEO_TYPE_NORMAL = 0;
  const VAX_VIDEO_TYPE_USER = 1;
  const VAX_VIDEO_TYPE_ADMIN = 2;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  const VAX_PUSH_PROVIDER_IOS = 0;
  const VAX_PUSH_PROVIDER_ANDROID = 1;

  const VAX_MEDIA_DETECT_VAD_TYPE_INBOUND = 0;
  const VAX_MEDIA_DETECT_VAD_TYPE_OUTBOUND = 1;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  const VAX_ERROR_LOAD_COM_MSG_A = 'Unable to load VaxTeleServerCOM.dll COM component.';
  const VAX_ERROR_LOAD_COM_MSG_B = 'Please run command prompt as administrator.';
  const VAX_ERROR_LOAD_COM_MSG_C = 'Register the COM using regsvr32 command and try again.';
  const VAX_ERROR_LOAD_COM_MSG_D = 'e.g. regsvr32 VaxTeleServerCOM.dll';

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  public

  constructor Create(); reintroduce; overload;
  procedure SetLicenseKey(sLicenseKey: String);

  function Initialize(sDomainRealm: String): Boolean;
  procedure UnInitialize();

  function OpenNetworkUDP(sListenIP: String; nListenPort: Integer): Boolean;
  function OpenNetworkTCP(sListenIP: String; nListenPort: Integer): Boolean;
  function OpenNetworkTLS(sListenIP: String; nListenPort: Integer; sCertPEM: String): Boolean;

  procedure CloseNetworkUDP;
  procedure CloseNetworkTCP;
  procedure CloseNetworkTLS;

  function SetNetworkMediaRTP(sListenIP: String; nListenStartPort: Integer): Boolean;

  function AutoForwardStatusResponseSIP(nSessionId: Integer; bDisable: Boolean): Boolean;
  function CryptoMediaNONE(bForced: Boolean): Boolean;
  function CryptoMediaSDP(bForced: Boolean): Boolean;

  function AddUser(sUserName: String; sPassword: String; sCodecList: String): Boolean;
  procedure RemoveUser(sUserName: String);

  function AcceptRegister(nRegId: Integer): Boolean;
  function RejectRegister(nRegId: Integer; nStatusCode: Integer; sReasonPhrase: String): Boolean;
  function AuthRegister(nRegId: Integer): Boolean;

  function AddLine(sLineName: String; nLineType: Integer; sDisplayName: String; sUserName: String; sAuthLogin: String; sAuthPwd: String; sDomainRealm: String; sServerAddr: String; nServerPort: Integer; sAudioCodecList: String): Boolean;
  procedure RemoveLine(sLineName: String);

  function RegisterLine(sLineName: String; nExpire: Integer): Boolean;
  function UnRegisterLine(sLineName: String): Boolean;

  function AcceptCallSession(nSessionId: Integer; sCallerName: String; sCallerId: String; sDialNo: String; sToPeerName: String; sRouteUID: String; nTimeout: Integer): Boolean;
  procedure RejectCallSession(nSessionId: Integer; nStatusCode: Integer; sReasonPhrase: String);
  procedure CloseCallSession(nSessionId: Integer);

  function DialCallSession(sCallerName: String; sCallerId: String; sDialNo: String; sToPeerName: String; nTimeout: Integer): Integer;

  function AcceptTransferBlind(nTransfererSessionId: Integer; sCallerName: String; sCallerId: String; sTransferTo: String; sToPeerName: String; sRouteUID: String; nTimeout: Integer): Boolean;
  function AcceptTransferConsult(nTransfererSessionId: Integer; nTransferToSessionId: Integer): Boolean;
  procedure RejectTransfer(nSessionId: Integer);

  function PlayWaveStartToCallSession(nSessionId: Integer; nChannelId: Integer; nWaveId: Integer; bLoopPlay: Boolean; nPlayPos: Integer): Boolean;
  procedure PlayWaveStopToCallSession(nSessionId: Integer; nChannelId: Integer; nWaveId: Integer);

  function RecordWaveSetCacheSize(nCacheSize: Integer): Boolean;

  function RecordWaveStartToCallSession(nSessionId: Integer; nChannelId: Integer; sFileName: String; nTypeREC: Integer): Boolean;
  procedure RecordWaveStopToCallSession(nSessionId: Integer; nChannelId: Integer);
  function RecordWavePauseToCallSession(nSessionId: Integer; nChannelId: Integer; bEnable: Boolean): Boolean;

  function LoadWaveFile(sFileName: String): Integer;
  procedure UnLoadWaveID(nWaveId: Integer);

  function LoadMusicHold(sFileName: String): Boolean;
  procedure UnLoadMusicHold();

  function LoadWavePCM(pDataPCM: PByte; nSizePCM: Integer): Integer;

  function AcceptOnHoldRequest(nSessionId : Integer): Boolean;
  function AcceptOffHoldRequest(nSessionId: Integer): Boolean;

  function AcceptChatMessage(nChatMsgId: Integer; sToPeerName: String): Boolean;
  procedure RejectChatMessage(nChatMsgId: Integer; nStatusCode: Integer; sReasonPhrase: String);

  function AcceptChatStatusSubscribe(nStatusSubscribe: Integer; sMsgFrom: String; sMsgTo: String; sToPeerName: String): Boolean;
  procedure RejectChatStatusSubscribe(nStatusSubscribe: Integer; sMsgFrom: String; sMsgTo: String);

  function OpenConferenceRoom(sRoomName: String): Boolean;
  procedure CloseConferenceRoom(sRoomName: String);

  function AddCallSessionToConferenceRoom(sRoomName: String; nSessionId: Integer): Boolean;
  procedure RemoveCallSessionFromConferenceRoom(nSessionId: Integer);

  function PlayWaveStartToConferenceRoom(sRoomName: String; lWaveId: Integer; bLoop: Boolean; nPlayPos: Integer): Boolean;
  function PlayWaveStopToConferenceRoom(sRoomName: String; lWaveId: Integer): Boolean;

  function RecordWaveStartToConferenceRoom(sRoomName: String; sFileName: String; nTypeREC: Integer): Boolean;
  function RecordWaveStopToConferenceRoom(sRoomName: String): Boolean;
  function RecordWavePauseToConferenceRoom(sRoomName: String; bEnable: Boolean): Boolean;

  function AudioSessionLost(bEnable: Boolean; nTimeout: Integer): Boolean;
  function SendInfoVM(sUserLogin: String; nNewMsgCount: Integer; nOldMsgCount: Integer; bMsgWaiting: Boolean): Integer;

  function StartVaxTeleTick(nTickId: Integer; nElapse: Integer): Boolean;
  function StopVaxTeleTick(nTickId: Integer): Boolean;

  function SetUserAgentName(sName: String): Boolean;
  function GetUserAgentName(): String;

  function SetSessionNameSDP(sName: String): Boolean;
  function GetSessionNameSDP(): String;

  function SendDigitDTMF(nSessionId: Integer; nChannelId: Integer; sDigitDTMF: String; nTypeDTMF: Integer): Boolean;
  function DetectDigitDTMF(nSessionId: Integer; nChannelId: Integer; nTypeDTMF: Integer; bEnable: Boolean; nTimeout: Integer): Boolean;

  function GetVaxErrorCode(): Integer;

  function DialToneToCallSession(bEnable: Boolean; nSessionId: Integer; nWaveId: Integer): Boolean;
  function DiagnosticLogSIP(bInbound: Boolean; bOutbound: Boolean): Boolean;

  function AddRingGroup(sGroupName: String): Boolean;
  procedure RemoveRingGroup(sGroupName: String);
  function AddRingGroupAgent(sGroupName: String; sUserName: String): Boolean;
  procedure RemoveRingGroupAgent(sGroupName: String; sUserName: String);
  function SetRingGroupProcessMode(sGroupName: String; nProcessMode: Integer; nProcessType: Integer): Boolean;
  function SetRingGroupAgentPriority(sGroupName: String; sUserName: String; nPriority: Integer): Boolean;

  function AddCallSessionToRingGroup(sGroupName: String; sCallerName: String; sCallerId: String; nSessionId: Integer): Boolean;
  function RemoveCallSessionFromRingGroup(nSessionId: Integer): Boolean;

  function AddCallPickUpGroup(sGroupName: String): Boolean;
  procedure RemoveCallPickUpGroup(sGroupName: String);
  function AddCallPickUpGroupMember(sGroupName: String; sUserName: String): Boolean;
  procedure RemoveCallPickUpGroupMember(sGroupName: String; sUserName: String);

  function PickUpCall(nSessionId: Integer; sUserName: String): Boolean;
  function ParkCallSession(nSessionId: Integer; nChannelId: Integer; nSlotId: Integer): Boolean;
  function ConnectToParkedCallSession(nSessionId: Integer; nChannelId: Integer; nSlotId: Integer): Boolean;

  function AddQueue(sQueueName: String): Boolean;
  procedure RemoveQueue(sQueueName: String);
  function AddQueueAgent(sQueueName: String; sUserName: String): Boolean;
  procedure RemoveQueueAgent(sQueueName: String; sUserName: String);
  function SetQueueAgentPriority(sQueueName: String; sUserName: String; nPriority: Integer): Boolean;
  function SetQueueAgentStatus(sQueueName: String; sAgentName: String; lStatusId: Integer): Boolean;
  function SetQueueProcessMode(sQueueName: String; nProcessMode: Integer; nProcessType: Integer): Boolean;

  function AddCallSessionToQueue(sQueueName: String; sCallerName: String; sCallerId: String; nSessionId: Integer; nTimeout: Integer): Boolean;
  function RemoveCallSessionFromQueue(nSessionId: Integer): Boolean;

  function AddStealthListener(nStealthSessionId: Integer; sCapturePeerName: String): Boolean;
  function MoveCall(nSrcSessionId: Integer; nChannelId: Integer; nDscSessionId: Integer): Boolean;

  function ConnectToServerREC(nSessionId: Integer; nChannelId: Integer; sCallerName: String; sCallerId: String; sDialNo: String; sToPeerName: String; nTimeout: Integer): Boolean;
  function MuteCallServerREC(nSessionId: Integer; nChannelId: Integer; nMuteType: Integer): Boolean;

  function SetExtDataREC(nSessionId: Integer; nChannelId: Integer; sExtData: String): Boolean;
  function SendNotifyMsgSIP(sMsgFrom: String; sMsgTo: String; sToPeerName: String): Integer;

  function AdjustCallSessionVoiceType(nSessionId: Integer; nChannelId: Integer; nVoiceTypeId: Integer): Boolean;
  function AdjustCallSessionVideoType(nSessionId: Integer; nChannelId: Integer; nVideoTypeId: Integer): Boolean;

  function GetCallSessionPeerType(nSessionId: Integer; nChannelId: Integer): Integer;
  function GetCallSessionPeerName(nSessionId: Integer; nChannelId: Integer): String;

  function AddNetworkRouteSIP(sAssignedIP: String; sRouterIP: String): Boolean;
  function AddNetworkRouteRTP(sAssignedIP: String; sRouterIP: String): Boolean;

  function RefreshCallSession(nSessionId: Integer; nChannelId: Integer; sCallerName: String; sCallerId: String; sAudioCodecList: String; nAudioFlowType: Integer; nVideoFlowType: Integer; nTimeout: Integer): Boolean;
  function GetCallCount(): Integer;

  function AddUserRouteUID(sUserName: String; sRouteUID: String): Boolean;
  function AddLineRouteUID(sLineName: String; sRouteUID: String; sDialOutPrefix: String): Boolean;

  function AddRingGroupRouteUID(sGroupName: String; sRouteUID: String): Boolean;
  function AddCallPickUpGroupRouteUID(sRouteUID: String): Boolean;

  function AddQueueRouteUID(sQueueName: String; sRouteUID: String): Boolean;

  function AddCallParkRouteUID(sRouteUID: String): Boolean;
  function AddConferenceRoomRouteUID(sRoomName: String; sRouteUID: String): Boolean;
  function AddStealthListenRouteUID(sRouteUID: String): Boolean;

  procedure RemoveRouteUID(sRouteUID: String);

  function SendAudioPCM(nSessionId: Integer; nChannelId: Integer; pDataPCM: PByte; nSizePCM: Integer; nTypePCM: Integer): Boolean;
  function AccessAudioPCM(nSessionId: Integer; nChannelId: Integer; sPipeName: String; nAccessType: Integer): Boolean;

  function ActivatePushSIP(bActivate: Boolean; nWaitSeconds: Integer): Boolean;
  function SetUserPushSIP(sUserName: String; nProviderPN: Integer; sProjectPN: String; sDevicePN: String): Boolean;
  function AttachRegister(nRegId: Integer; sUserName: String): Boolean;

  function SendReqHoldCall(nSessionId: Integer; nChannelId: Integer): Boolean;
  function SendReqUnHoldCall(nSessionId: Integer; nChannelId: Integer): Boolean;

  function CallSessionAttachCall(nSessionId: Integer; nVoiceTypeId: Integer; nVideoTypeId: Integer; nAttachToSessionId: Integer; nAttachToChannelId: Integer): Boolean;
  procedure CallSessionDetachCall(nSessionId: Integer; nVoiceTypeId: Integer; nVideoTypeId: Integer);

  function AttackDetectScanSIP(sDomainName: String): Boolean;
  function AttackDetectFloodSIP(nReqRecvLimit: Integer): Boolean;
  function AttackDetectBruteForceSIP(nFailureCount: Integer; nFailureInterval: Integer): Boolean;

  function DetectStartVAD(nSessionId: Integer; nChannelId: Integer; nAudioLevelVU: Integer; nSilenceLengthPCM: Integer; nSilenceCountPCM: Integer; nAnalysisLengthPCM: Integer; nExpiryLengthPCM: Integer; nProcessLengthPCM: Integer; nDetectType: Integer): Boolean;
  procedure DetectStopVAD(nSessionId: Integer; nChannelId: Integer);


  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  private
  procedure InvokeEvent(DispID: LongInt; var Params: TVariantArray); override;

  public

  procedure OnLineRegisterTrying(sLineName: String); virtual;
  procedure OnLineRegisterFailed(sLineName: String; nStatusCode: Integer; sReasonPhrase: String); virtual;
  procedure OnLineRegisterSuccess(sLineName: String); virtual;

  procedure OnLineUnRegisterTrying(sLineName: String); virtual;
  procedure OnLineUnRegisterFailed(sLineName: String; nStatusCode: Integer; sReasonPhrase: String); virtual;
  procedure OnLineUnRegisterSuccess(sLineName: String); virtual;

  procedure OnUnRegisterUser(sUserLogin: String); virtual;
  procedure OnRegisterUser(sUserLogin: String; sDomain: String; sUserAgentName: String; sFromIP: String; nFromPort: Integer; nRegId: Integer); virtual;
  procedure OnRegisterUserSuccess(sUserLogin: String; sFromIP: String; nFromPort: Integer; nRegId: Integer); virtual;
  procedure OnRegisterUserFailed(sUserLogin: String; sFromIP: String; nFromPort: Integer; nRegId: Integer); virtual;

  procedure OnChatMessageText(nChatMsgId: Integer; sMsgFrom: String; sMsgTo: String; sMsgText: String; nFromPeerType: Integer; sFromPeerName: String; sFromIP: String; nFromPort: Integer); virtual;
  procedure OnChatMessageTyping(nChatMsgId: Integer; sMsgFrom: String; sMsgTo: String; bIsTypingStart: Boolean; nFromPeerType: Integer; sFromPeerName: String; sFromIP: String; nFromPort: Integer); virtual;
  procedure OnChatStatusSubscribe(nSubscrbId: Integer; sMsgFrom: String; sMsgTo: String; nFromPeerType: Integer; sFromPeerName: String; sFromIP: String; nFromPort: Integer); virtual;

  procedure OnChatMessageSuccess(nChatMsgId: Integer); virtual;
  procedure OnChatMessageFailed(nChatMsgId: Integer; nStatusCode: Integer; sReasonPhrase: String); virtual;
  procedure OnChatMessageTimeout(nChatMsgId: Integer); virtual;

  procedure OnIncomingCall(nSessionId: Integer; sCallerName: String; sCallerId: String; sDialNo: String; nFromPeerType: Integer; sFromPeerName: String; sRouteUID: String; nRouteType: Integer; sRouteName: String; sUserAgentName: String; sFromIP: String; nFromPort: Integer); virtual;
  procedure OnCallSessionFailed(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String; sContact: String); virtual;
  procedure OnCallSessionConnected(nSessionId: Integer); virtual;
  procedure OnCallSessionClosed(nSessionId: Integer; nChannelId: Integer; nReasonCode: Integer); virtual;

  procedure OnCallSessionConnecting(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String); virtual;
  procedure OnCallSessionLost(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnCallSessionHangup(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnCallSessionTimeout(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnCallSessionCancelled(nSessionId: Integer); virtual;

  procedure OnCallSessionOnHold(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnCallSessionOffHold(nSessionId: Integer; nChannelId: Integer); virtual;

  procedure OnCallSessionTransferBlind(nTransfererSessionId: Integer; nTransfererChannelId: Integer; sTransferer: String; sTransferee: String; sTransferTo: String; sRouteUID: String; nRouteType: Integer; sRouteName: String); virtual;
  procedure OnCallSessionTransferConsult(nTransfererSessionId: Integer; nTransfererChannelId: Integer; nTransferToSessionId: Integer; nTransferToChannelId: Integer; sTransferer: String; sTransferee: String; sTransferTo: String); virtual;

  procedure OnCallSessionTransfering(nSessionId: Integer; nTransferType: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String); virtual;
  procedure OnCallSessionTransferFailed(nSessionId: Integer; nTransferType: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String); virtual;
  procedure OnCallSessionTransferTimeout(nSessionId: Integer; nTransferType: Integer; nChannelId: Integer); virtual;
  procedure OnCallSessionTransfered(nSessionId: Integer; nTransferType: Integer); virtual;

  procedure OnDetectedDigitDTMF(nSessionId: Integer; nChannelId: Integer; sDigitDTMF: String; nTypeDTMF: Integer); virtual;
  procedure OnOutgoingDiagnosticLog(sMsgSIP: String; sToIP: String; nToPort: Integer); virtual;
  procedure OnIncomingDiagnosticLog(sMsgSIP: String; sFromIP: String; nFromPort: Integer); virtual;

  procedure OnVaxTeleTick(nTickId: Integer); virtual;

  procedure OnSendTimeoutVM(nMsgIdVM: Integer); virtual;
  procedure OnSendSuccessVM(nMsgIdVM: Integer); virtual;

  procedure OnCallSessionDialToneStarted(nSessionId: Integer; nChannelId: Integer; nWaveId: Integer); virtual;
  procedure OnCallSessionDialToneEnded(nSessionId: Integer; nChannelId: Integer; nWaveId: Integer); virtual;

  procedure OnBusyLampSubscribe(nSubscrbId: Integer; sUserName: String; sToUserName: String; sFromIP: String; nFromPort: Integer); virtual;
  procedure OnBusyLampUnSubscribe(nSubscrbId: Integer; sUserName: String; sToUserName: String; sFromIP: String; nFromPort: Integer); virtual;
  procedure OnBusyLampSubscribeSuccess(nSubscrbId: Integer; sUserName: String); virtual;
  procedure OnBusyLampSubscribeFailed(nSubscrbId: Integer; UserName: String); virtual;
  procedure OnBusyLampSendStatus(sFromUserName: String; sToUserName: String; nStateId: Integer); virtual;

  procedure OnCallSessionPlayWaveDone(nSessionId: Integer; nChannelId: Integer; nWaveId: Integer); virtual;
  procedure OnConferenceRoomPlayWaveDone(sRoomName: String; nWaveId: Integer); virtual;

  procedure OnCallSessionCreated(nSessionId: Integer; nReasonCode: Integer); virtual;
  procedure OnCallSessionDetectedAMD(nSessionId: Integer; nChannelId: Integer; bIsHuman: Boolean); virtual;

  procedure OnCallSessionRecordedWaveREC(nSessionId: Integer; nChannelId: Integer; pDataREC: PByte; nSizeREC: Integer; nTypeREC: Integer); virtual;
  procedure OnConferenceRoomRecordedWaveREC(sRoomName: String; pDataREC: PByte; nSizeREC: Integer; nTypeREC: Integer); virtual;

  procedure OnVaxErrorLog(sFuncName: String; nErrorCode: Integer; sErrorMsg: String); virtual;

  procedure OnAddCallSessionToQueueSuccess(sQueueName: String; nSessionId: Integer); virtual;
  procedure OnAddCallSessionToQueueFailed(sQueueName: String; nSessionId: Integer); virtual;

  procedure OnVaxLicenseChannel(nTotalChannels: Integer; nUsedChannels: Integer); virtual;

  procedure OnAddCallSessionToRingGroupSuccess(sGroupName: String; nSessionId: Integer); virtual;
  procedure OnAddCallSessionToRingGroupFailed(sGroupName: String; nSessionId: Integer); virtual;

  procedure OnSendReqTransferCallTimeout(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnSendReqTransferCallAccepted(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnSendReqTransferCallFailed(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String); virtual;

  procedure OnQualityReportPUBLISH(sMsgSIP: String; sMsgSDP: String; sFromIP: String; nFromPort: Integer); virtual;

  procedure OnServerConnectingREC(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String); virtual;
  procedure OnServerConnectedREC(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnServerFailedREC(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String); virtual;
  procedure OnServerTimeoutREC(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnServerHungupREC(nSessionId: Integer; nChannelId: Integer); virtual;

  procedure OnQueuePlayWaveStarted(nEventType: Integer; sQueueName: String; nSessionId: Integer); virtual;
  procedure OnQueuePlayWaveEnded(nEventType: Integer; sQueueName: String; nSessionId: Integer); virtual;

  procedure OnQueueAgentConnectStarted(sQueueName: String; sAgentName: String; nSessionId: Integer); virtual;
  procedure OnQueueAgentConnectTrying(sQueueName: String; sAgentName: String; nSessionId: Integer; nStatusCode: Integer; sReasonPhrase: String); virtual;
  procedure OnQueueAgentConnectFailed(sQueueName: String; sAgentName: String; nSessionId: Integer; nStatusCode: Integer; sReasonPhrase: String); virtual;
  procedure OnQueueAgentConnectTimeout(sQueueName: String; sAgentName: String; nSessionId: Integer); virtual;
  procedure OnQueueAgentConnectSuccess(sQueueName: String; sAgentName: String; nSessionId: Integer); virtual;

  procedure OnChatStatusSendSubscribeSuccess(nSubscrbId: Integer); virtual;
  procedure OnChatStatusSendSubscribeFailed(nSubscrbId: Integer; nStatusCode: Integer; sReasonPhrase: String); virtual;

  procedure OnSendNotifyMsgSuccess(nMsgId: Integer); virtual;
  procedure OnSendNotifyMsgFailed(nMsgId: Integer; nStatusCode: Integer; sReasonPhrase: String); virtual;
  procedure OnCallSessionErrorLog(nSessionId: Integer; nChannelId: Integer; nErrorCode: Integer; sErrorMsg: String); virtual;

  procedure OnCallParkPlayWaveStarted(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnCallParkPlayWaveStop(nSessionId: Integer; nChannelId: Integer); virtual;

  procedure OnCallSessionAccessAudioPCM(nSessionId: Integer; nChannelId: Integer; nAccessType: Integer; pDataPCM: PByte; nSizePCM: Integer; nTypePCM: Integer); virtual;
  procedure OnStealthListenerAttached(nAttachType: Integer; nStealthSessionId: Integer; nAttachSessionId: Integer; nAttachChannelId: Integer); virtual;

  procedure OnCallSessionPushSIP(nSessionId: Integer; nChannelId: Integer; sCallerName: String; sCallerId: String; nProviderPN: Integer; sProjectPN: String; sDevicePN: String); virtual;
  procedure OnRegisterUserPushSIP(sUserName: String; nProviderPN: Integer; sProjectPN: String; sDevicePN: String); virtual;

  procedure OnSendReqHoldCallSuccess(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnSendReqHoldCallTrying(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnSendReqHoldCallTimeout(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnSendReqHoldCallFailed(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: WideString); virtual;

  procedure OnSendReqUnHoldCallSuccess(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnSendReqUnHoldCallTrying(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnSendReqUnHoldCallTimeout(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnSendReqUnHoldCallFailed(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: WideString); virtual;

  procedure OnAttackDetectedScanSIP(sReqMethod: Integer; sAddrIP: WideString; nAddrPort: Integer; nAddrType: Integer); virtual;
  procedure OnAttackDetectedFloodSIP(sAddrIP: WideString; nAddrPort: Integer; nAddrType: Integer); virtual;
  procedure OnAttackDetectedBruteForceSIP(sReqMethod: Integer; nAuthFailureCount: Integer; sAddrIP: WideString; nAddrPort: Integer; nAddrType: Integer); virtual;

  procedure OnCallSessionMediaDetectStartedVAD(nSessionId: Integer; nChannelId: Integer); virtual;
  procedure OnCallSessionMediaDetectCompletedVAD(nSessionId: Integer; nChannelId: Integer; pDataPCM: PByte; nSizePCM: Integer; nTypePCM: Integer); virtual;
  procedure OnCallSessionMediaDetectExpiredVAD(nSessionId: Integer; nChannelId: Integer); virtual;

end;


implementation

{$ASSERTIONS ON}

var
  m_bLoadedCOM: Boolean;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  constructor TVaxServerCOM.Create();
  begin
    inherited Create(Nil);

    try
      inherited SetLicenseKey('');
    except
      m_bLoadedCOM := False;
      Exit();
    end;

    m_bLoadedCOM := True;
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  procedure TVaxServerCOM.SetLicenseKey(sLicenseKey: String);
  begin

    if(m_bLoadedCOM = False) Then
    Begin
       Exit();
    end;

    inherited SetLicenseKey(sLicenseKey);

  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.Initialize(sDomainRealm: String): Boolean;
  begin

    if(m_bLoadedCOM = False) Then
    Begin
      OnVaxErrorLog('', -1, VAX_ERROR_LOAD_COM_MSG_A);
      OnVaxErrorLog('', -1, VAX_ERROR_LOAD_COM_MSG_B);
      OnVaxErrorLog('', -1, VAX_ERROR_LOAD_COM_MSG_C);
      OnVaxErrorLog('', -1, VAX_ERROR_LOAD_COM_MSG_D);
      Exit(False);
    end;

    Result := Boolean(inherited Initialize(sDomainRealm));

  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  procedure TVaxServerCOM.UnInitialize();
  begin

    if(m_bLoadedCOM = False) Then
    Begin
       Exit();
    end;

    inherited UnInitialize();

  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.OpenNetworkUDP(sListenIP: String; nListenPort: Integer): Boolean;
  begin
    Result := Boolean(inherited OpenNetworkUDP(sListenIP, nListenPort));
  end;

  function TVaxServerCOM.OpenNetworkTCP(sListenIP: String; nListenPort: Integer): Boolean;
  begin
    Result := Boolean(inherited OpenNetworkTCP(sListenIP, nListenPort));
  end;

  function TVaxServerCOM.OpenNetworkTLS(sListenIP: String; nListenPort: Integer; sCertPEM: String): Boolean;
  begin
    Result := Boolean(inherited OpenNetworkTLS(sListenIP, nListenPort, sCertPEM));
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  procedure TVaxServerCOM.CloseNetworkUDP();
  begin
    inherited CloseNetworkUDP();
  end;

  procedure TVaxServerCOM.CloseNetworkTCP();
  begin
    inherited CloseNetworkTCP();
  end;

  procedure TVaxServerCOM.CloseNetworkTLS();
  begin
    inherited CloseNetworkTLS();
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.SetNetworkMediaRTP(sListenIP: String; nListenStartPort: Integer): Boolean;
  begin
    Result := Boolean(inherited SetNetworkMediaRTP(sListenIP, nListenStartPort));
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.AutoForwardStatusResponseSIP(nSessionId: Integer; bDisable: Boolean): Boolean;
  begin
    Result := Boolean(inherited AutoForwardStatusResponseSIP(nSessionId, bDisable));
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.CryptoMediaNONE(bForced: Boolean): Boolean;
  begin
    Result := Boolean(inherited CryptoMediaNONE(bForced));
  end;

  function TVaxServerCOM.CryptoMediaSDP(bForced: Boolean): Boolean;
  begin
    Result := Boolean(inherited CryptoMediaSDP(bForced));
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.AddUser(sUserName: String; sPassword: String; sCodecList: String): Boolean;
  begin
    Result := Boolean(inherited AddUser(sUserName, sPassword, sCodecList));
  end;

  procedure TVaxServerCOM.RemoveUser(sUserName: String);
  begin
    inherited RemoveUser(sUserName);
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.AcceptRegister(nRegId: Integer): Boolean;
  begin
    Result := Boolean(inherited AcceptRegister(nRegId));
  end;

  function TVaxServerCOM.RejectRegister(nRegId: Integer; nStatusCode: Integer; sReasonPhrase: String): Boolean;
  begin
    Result := Boolean(inherited RejectRegister(nRegId, nStatusCode, sReasonPhrase));
  end;

  function TVaxServerCOM.AuthRegister(nRegId: Integer): Boolean;
  begin
    Result := Boolean(inherited AuthRegister(nRegId));
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.AddLine(sLineName: String; nLineType: Integer; sDisplayName: String; sUserName: String; sAuthLogin: String; sAuthPwd: String; sDomainRealm: String; sServerAddr: String; nServerPort: Integer; sAudioCodecList: String): Boolean;
  begin
    Result := Boolean(inherited AddLine(sLineName, nLineType, sDisplayName, sUserName, sAuthLogin, sAuthPwd, sDomainRealm, sServerAddr, nServerPort, sAudioCodecList));
  end;

  procedure TVaxServerCOM.RemoveLine(sLineName: String);
  begin
    inherited RemoveLine(sLineName);
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.RegisterLine(sLineName: String; nExpire: Integer): Boolean;
  begin
    Result := Boolean(inherited RegisterLine(sLineName, nExpire));
  end;

  function TVaxServerCOM.UnRegisterLine(sLineName: String): Boolean;
  begin
    Result := Boolean(inherited UnRegisterLine(sLineName));
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.AcceptCallSession(nSessionId: Integer; sCallerName: String; sCallerId: String; sDialNo: String; sToPeerName: String; sRouteUID: String; nTimeout: Integer): Boolean;
  begin
    Result := Boolean(inherited AcceptCallSession(nSessionId, sCallerName, sCallerId, sDialNo, sToPeerName, sRouteUID, nTimeout));
  end;

  procedure TVaxServerCOM.RejectCallSession(nSessionId: Integer; nStatusCode: Integer; sReasonPhrase: String);
  begin
    inherited RejectCallSession(nSessionId, nStatusCode, sReasonPhrase);
  end;

  procedure TVaxServerCOM.CloseCallSession(nSessionId: Integer);
  begin
    inherited CloseCallSession(nSessionId);
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.DialCallSession(sCallerName: String; sCallerId: String; sDialNo: String; sToPeerName: String; nTimeout: Integer): Integer;
  begin
    Result := inherited DialCallSession(sCallerName, sCallerId, sDialNo, sToPeerName, nTimeout);
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.AcceptTransferBlind(nTransfererSessionId: Integer; sCallerName: String; sCallerId: String; sTransferTo: String; sToPeerName: String; sRouteUID: String; nTimeout: Integer): Boolean;
  begin
    Result := inherited AcceptTransferBlind(nTransfererSessionId, sCallerName, sCallerId, sTransferTo, sToPeerName, sRouteUID, nTimeout);
  end;

  function TVaxServerCOM.AcceptTransferConsult(nTransfererSessionId: Integer; nTransferToSessionId: Integer): Boolean;
  begin
    Result := inherited AcceptTransferConsult(nTransfererSessionId, nTransferToSessionId);
  end;

  procedure TVaxServerCOM.RejectTransfer(nSessionId: Integer);
  begin
    inherited RejectTransfer(nSessionId);
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.PlayWaveStartToCallSession(nSessionId: Integer; nChannelId: Integer; nWaveId: Integer; bLoopPlay: Boolean; nPlayPos: Integer): Boolean;
  begin
    Result := Boolean(inherited PlayWaveStartToCallSession(nSessionId, nChannelId, nWaveId, bLoopPlay, nPlayPos));
  end;

  procedure TVaxServerCOM.PlayWaveStopToCallSession(nSessionId: Integer; nChannelId: Integer; nWaveId: Integer);
  begin
    inherited PlayWaveStopToCallSession(nSessionId,  nChannelId, nWaveId);
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.RecordWaveStartToCallSession(nSessionId: Integer; nChannelId: Integer; sFileName: String; nTypeREC: Integer): Boolean;
  begin
    Result := Boolean(inherited RecordWaveStartToCallSession(nSessionId, nChannelId, sFileName, nTypeREC));
  end;

  procedure TVaxServerCOM.RecordWaveStopToCallSession(nSessionId: Integer; nChannelId: Integer);
  begin
    inherited RecordWaveStopToCallSession(nSessionId, nChannelId);
  end;

  function TVaxServerCOM.RecordWavePauseToCallSession(nSessionId: Integer; nChannelId: Integer; bEnable: Boolean): Boolean;
  begin
    Result := Boolean(inherited RecordWavePauseToCallSession(nSessionId, nChannelId, bEnable));
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.LoadWaveFile(sFileName: String): Integer;
  begin
    Result := Integer(inherited LoadWaveFile(sFileName));
  end;

  procedure TVaxServerCOM.UnLoadWaveID(nWaveId: Integer);
  begin
    inherited UnLoadWaveID(nWaveId);
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  function TVaxServerCOM.LoadMusicHold(sFileName: String): Boolean;
  begin
    Result := Boolean(inherited LoadMusicHold(sFileName));
  end;

  procedure TVaxServerCOM.UnLoadMusicHold();
  begin
    inherited UnLoadMusicHold();
  end;

  function TVaxServerCOM.LoadWavePCM(pDataPCM: PByte; nSizePCM: Integer): Integer;
  begin
    Result := Integer(inherited LoadWavePCM(Int64(pDataPCM), nSizePCM,0));
  end;

  function TVaxServerCOM.AcceptOnHoldRequest(nSessionId : Integer): Boolean;
  begin
    Result := Boolean(inherited AcceptOnHoldRequest(nSessionId));
  end;

  function TVaxServerCOM.AcceptOffHoldRequest(nSessionId: Integer): Boolean;
  begin
    Result := Boolean(inherited AcceptOffHoldRequest(nSessionId));
  end;

  function TVaxServerCOM.AcceptChatMessage(nChatMsgId: Integer; sToPeerName: String): Boolean;
  begin
    Result := Boolean(inherited AcceptChatMessage(nChatMsgId, sToPeerName));
  end;

  procedure TVaxServerCOM.RejectChatMessage(nChatMsgId: Integer; nStatusCode: Integer; sReasonPhrase: String);
  begin
    inherited RejectChatMessage(nChatMsgId, nStatusCode, sReasonPhrase);
  end;

  function TVaxServerCOM.AcceptChatStatusSubscribe(nStatusSubscribe: Integer; sMsgFrom: String; sMsgTo: String; sToPeerName: String): Boolean;
  begin
    Result := Boolean(inherited AcceptChatStatusSubscribe(nStatusSubscribe, sMsgFrom, sMsgTo, sToPeerName));
  end;

  procedure TVaxServerCOM.RejectChatStatusSubscribe(nStatusSubscribe: Integer; sMsgFrom: String; sMsgTo: String);
  begin
    inherited RejectChatStatusSubscribe(nStatusSubscribe, sMsgFrom, sMsgTo);
  end;

  function TVaxServerCOM.OpenConferenceRoom(sRoomName: String): Boolean;
  begin
    Result := Boolean(inherited OpenConferenceRoom(sRoomName));
  end;

  procedure TVaxServerCOM.CloseConferenceRoom(sRoomName: String);
  begin
    inherited CloseConferenceRoom(sRoomName);
  end;

  function TVaxServerCOM.AddCallSessionToConferenceRoom(sRoomName: String; nSessionId: Integer): Boolean;
  begin
    Result := Boolean(inherited AddCallSessionToConferenceRoom(sRoomName, nSessionId));
  end;

  procedure TVaxServerCOM.RemoveCallSessionFromConferenceRoom(nSessionId: Integer);
  begin
    inherited RemoveCallSessionFromConferenceRoom(nSessionId);
  end;

  function TVaxServerCOM.PlayWaveStartToConferenceRoom(sRoomName: String; lWaveId: Integer; bLoop: Boolean; nPlayPos: Integer): Boolean;
  begin
    Result := Boolean(inherited PlayWaveStartToConferenceRoom(sRoomName, lWaveId, bLoop, nPlayPos));
  end;

  function TVaxServerCOM.PlayWaveStopToConferenceRoom(sRoomName: String; lWaveId: Integer): Boolean;
  begin
    Result := Boolean(inherited PlayWaveStopToConferenceRoom(sRoomName, lWaveId));
  end;

  function TVaxServerCOM.RecordWaveStartToConferenceRoom(sRoomName: String; sFileName: String; nTypeREC: Integer): Boolean;
  begin
    Result := Boolean(inherited RecordWaveStartToConferenceRoom(sRoomName, sFileName, nTypeREC));
  end;

  function TVaxServerCOM.RecordWaveStopToConferenceRoom(sRoomName: String): Boolean;
  begin
    Result := Boolean(inherited RecordWaveStopToConferenceRoom(sRoomName));
  end;

  function TVaxServerCOM.RecordWavePauseToConferenceRoom(sRoomName: String; bEnable: Boolean): Boolean;
  begin
    Result := Boolean(inherited RecordWavePauseToConferenceRoom(sRoomName, bEnable));
  end;

  function TVaxServerCOM.AudioSessionLost(bEnable: Boolean; nTimeout: Integer): Boolean;
  begin
    Result := Boolean(inherited AudioSessionLost(bEnable, nTimeout));
  end;

  function TVaxServerCOM.SendInfoVM(sUserLogin: String; nNewMsgCount: Integer; nOldMsgCount: Integer; bMsgWaiting: Boolean): Integer;
  begin
    Result := Integer(inherited SendInfoVM(sUserLogin, nNewMsgCount, nOldMsgCount, bMsgWaiting));
  end;

  function TVaxServerCOM.StartVaxTeleTick(nTickId: Integer; nElapse: Integer): Boolean;
  begin
    Result := Boolean(inherited StartVaxTeleTick(nTickId, nElapse));
  end;

  function TVaxServerCOM.StopVaxTeleTick(nTickId: Integer): Boolean;
  begin
    Result := Boolean(inherited StopVaxTeleTick(nTickId));
  end;

  function TVaxServerCOM.SetUserAgentName(sName: String): Boolean;
  begin
    Result := Boolean(inherited SetUserAgentName(sName));
  end;

  function TVaxServerCOM.GetUserAgentName(): String;
  begin
    Result := inherited GetUserAgentName();
  end;

  function TVaxServerCOM.SetSessionNameSDP(sName: String): Boolean;
  begin
    Result := Boolean(inherited SetSessionNameSDP(sName));
  end;

  function TVaxServerCOM.GetSessionNameSDP(): String;
  begin
    Result := inherited GetSessionNameSDP();
  end;

  function TVaxServerCOM.SendDigitDTMF(nSessionId: Integer; nChannelId: Integer; sDigitDTMF: String; nTypeDTMF: Integer): Boolean;
  begin
    Result := Boolean(inherited SendDigitDTMF(nSessionId, nChannelId, sDigitDTMF, nTypeDTMF));
  end;

  function TVaxServerCOM.DetectDigitDTMF(nSessionId: Integer; nChannelId: Integer; nTypeDTMF: Integer; bEnable: Boolean; nTimeout: Integer): Boolean;
  begin
    Result := Boolean(inherited DetectDigitDTMF(nSessionId, nChannelId,  nTypeDTMF, bEnable, nTimeout));
  end;

  function TVaxServerCOM.GetVaxErrorCode(): Integer;
  begin
    Result := Integer(inherited GetVaxErrorCode());
  end;

  function TVaxServerCOM.DialToneToCallSession(bEnable: Boolean; nSessionId: Integer; nWaveId: Integer): Boolean;
  begin
    Result := Boolean(inherited DialToneToCallSession(bEnable, nSessionId, nWaveId));
  end;

  function TVaxServerCOM.DiagnosticLogSIP(bInbound: Boolean; bOutbound: Boolean): Boolean;
  begin
    Result := Boolean(inherited DiagnosticLogSIP(bInbound, bOutbound));
  end;

  function TVaxServerCOM.AddRingGroup(sGroupName: String): Boolean;
  begin
    Result := Boolean(inherited AddRingGroup(sGroupName));
  end;

  procedure TVaxServerCOM.RemoveRingGroup(sGroupName: String);
  begin
   inherited RemoveRingGroup(sGroupName);
  end;

  function TVaxServerCOM.AddRingGroupAgent(sGroupName: String; sUserName: String): Boolean;
  begin
    Result := Boolean(inherited AddRingGroupAgent(sGroupName, sUserName));
  end;

  procedure TVaxServerCOM.RemoveRingGroupAgent(sGroupName: String; sUserName: String);
  begin
    inherited RemoveRingGroupAgent(sGroupName, sUserName);
  end;

  function TVaxServerCOM.SetRingGroupProcessMode(sGroupName: String; nProcessMode: Integer; nProcessType: Integer): Boolean;
  begin
    Result := Boolean(inherited SetRingGroupProcessMode(sGroupName, nProcessMode, nProcessType));
  end;

  function TVaxServerCOM.SetRingGroupAgentPriority(sGroupName: String; sUserName: String; nPriority: Integer): Boolean;
  begin
    Result := Boolean(inherited SetRingGroupAgentPriority(sGroupName, sUserName, nPriority));
  end;

  function TVaxServerCOM.AddCallSessionToRingGroup(sGroupName: String; sCallerName: String; sCallerId: String; nSessionId: Integer): Boolean;
  begin
    Result := Boolean(inherited AddCallSessionToRingGroup(sGroupName, sCallerName, sCallerId, nSessionId));
  end;

  function TVaxServerCOM.RemoveCallSessionFromRingGroup(nSessionId: Integer): Boolean;
  begin
    Result := Boolean(inherited RemoveCallSessionFromRingGroup(nSessionId));
  end;

  function TVaxServerCOM.AddCallPickUpGroup(sGroupName: String): Boolean;
  begin
    Result := Boolean(inherited AddCallPickUpGroup(sGroupName));
  end;

  procedure TVaxServerCOM.RemoveCallPickUpGroup(sGroupName: String);
  begin
    inherited RemoveCallPickUpGroup(sGroupName);
  end;

  function TVaxServerCOM.AddCallPickUpGroupMember(sGroupName: String; sUserName: String): Boolean;
  begin
    Result := Boolean(inherited AddCallPickUpGroupMember(sGroupName, sUserName));
  end;

  procedure TVaxServerCOM.RemoveCallPickUpGroupMember(sGroupName: String; sUserName: String);
  begin
    inherited RemoveCallPickUpGroupMember(sGroupName, sUserName);
  end;

  function TVaxServerCOM.PickUpCall(nSessionId: Integer; sUserName: String): Boolean;
  begin
    Result := Boolean(inherited PickUpCall(nSessionId, sUserName));
  end;

  function TVaxServerCOM.ParkCallSession(nSessionId: Integer; nChannelId: Integer; nSlotId: Integer): Boolean;
  begin
    Result := Boolean(inherited ParkCallSession(nSessionId, nChannelId, nSlotId));
  end;

  function TVaxServerCOM.ConnectToParkedCallSession(nSessionId: Integer; nChannelId: Integer; nSlotId: Integer): Boolean;
  begin
    Result := Boolean(inherited ConnectToParkedCallSession(nSessionId, nChannelId, nSlotId));
  end;

  function TVaxServerCOM.AddQueue(sQueueName: String): Boolean;
  begin
    Result := Boolean(inherited AddQueue(sQueueName));
  end;

  procedure TVaxServerCOM.RemoveQueue(sQueueName: String);
  begin
    inherited RemoveQueue(sQueueName);
  end;

  function TVaxServerCOM.AddQueueAgent(sQueueName: String; sUserName: String): Boolean;
  begin
    Result := Boolean(inherited AddQueueAgent(sQueueName, sUserName));
  end;

  procedure TVaxServerCOM.RemoveQueueAgent(sQueueName: String; sUserName: String);
  begin
    inherited RemoveQueueAgent(sQueueName, sUserName);
  end;

  function TVaxServerCOM.SetQueueAgentPriority(sQueueName: String; sUserName: String; nPriority: Integer): Boolean;
  begin
    Result := Boolean(inherited SetQueueAgentPriority(sQueueName, sUserName, nPriority));
  end;

  function TVaxServerCOM.SetQueueAgentStatus(sQueueName: String; sAgentName: String; lStatusId: Integer): Boolean;
  begin
     Result := Boolean(inherited SetQueueAgentStatus(sQueueName, sAgentName, lStatusId));
  end;

  function TVaxServerCOM.SetQueueProcessMode(sQueueName: String; nProcessMode: Integer; nProcessType: Integer): Boolean;
  begin
    Result := Boolean(inherited SetQueueProcessMode(sQueueName, nProcessMode, nProcessType));
  end;

  function TVaxServerCOM.AddCallSessionToQueue(sQueueName: String; sCallerName: String; sCallerId: String; nSessionId: Integer; nTimeout: Integer): Boolean;
  begin
    Result := Boolean(inherited AddCallSessionToQueue(sQueueName, sCallerName, sCallerId, nSessionId, nTimeout));
  end;

  function TVaxServerCOM.RemoveCallSessionFromQueue(nSessionId: Integer): Boolean;
  begin
    Result := Boolean(inherited RemoveCallSessionFromQueue(nSessionId));
  end;

  function TVaxServerCOM.AddStealthListener(nStealthSessionId: Integer; sCapturePeerName: String): Boolean;
  begin
    Result := Boolean(inherited AddStealthListener(nStealthSessionId, sCapturePeerName));
  end;

  function TVaxServerCOM.MoveCall(nSrcSessionId: Integer; nChannelId: Integer; nDscSessionId: Integer): Boolean;
  begin
    Result := Boolean(inherited MoveCall(nSrcSessionId, nChannelId, nDscSessionId));
  end;

  function TVaxServerCOM.ConnectToServerREC(nSessionId: Integer; nChannelId: Integer; sCallerName: String; sCallerId: String; sDialNo: String; sToPeerName: String; nTimeout: Integer): Boolean;
  begin
    Result := Boolean(inherited ConnectToServerREC(nSessionId, nChannelId, sCallerName, sCallerId, sDialNo, sToPeerName, nTimeout));
  end;

  function TVaxServerCOM.MuteCallServerREC(nSessionId: Integer; nChannelId: Integer; nMuteType: Integer): Boolean;
  begin
    Result := Boolean(inherited MuteCallServerREC(nSessionId, nChannelId, nMuteType));
  end;

  function TVaxServerCOM.SetExtDataREC(nSessionId: Integer; nChannelId: Integer; sExtData: String): Boolean;
  begin
    Result := Boolean(Inherited SetExtDataREC(nSessionId, nChannelId, sExtData));
  end;

  function TVaxServerCOM.SendNotifyMsgSIP(sMsgFrom: String; sMsgTo: String; sToPeerName: String): Integer;
  begin
    Result := Integer(Inherited SendNotifyMsgSIP(sMsgFrom, sMsgTo, sToPeerName));
  end;

  function TVaxServerCOM.AdjustCallSessionVoiceType(nSessionId: Integer; nChannelId: Integer; nVoiceTypeId: Integer): Boolean;
  begin
    Result := Boolean(Inherited AdjustCallSessionVoiceType(nSessionId, nChannelId, nVoiceTypeId));
  end;

  function TVaxServerCOM.AdjustCallSessionVideoType(nSessionId: Integer; nChannelId: Integer; nVideoTypeId: Integer): Boolean;
  begin
    Result := Boolean(Inherited AdjustCallSessionVideoType(nSessionId, nChannelId, nVideoTypeId));
  end;

  function TVaxServerCOM.GetCallSessionPeerType(nSessionId: Integer; nChannelId: Integer): Integer;
  begin
    Result := Integer(Inherited GetCallSessionPeerType(nSessionId, nChannelId));
  end;

  function TVaxServerCOM.GetCallSessionPeerName(nSessionId: Integer; nChannelId: Integer): String;
  begin
    Result := String(Inherited GetCallSessionPeerName(nSessionId, nChannelId));
  end;

  function TVaxServerCOM.AddNetworkRouteSIP(sAssignedIP: String; sRouterIP: String): Boolean;
  begin
    Result := Boolean(Inherited AddNetworkRouteSIP(sAssignedIP, sRouterIP));
  end;

  function TVaxServerCOM.AddNetworkRouteRTP(sAssignedIP: String; sRouterIP: String): Boolean;
  begin
    Result := Boolean(Inherited AddNetworkRouteRTP(sAssignedIP, sRouterIP));
  end;

  function TVaxServerCOM.RefreshCallSession(nSessionId: Integer; nChannelId: Integer; sCallerName: String; sCallerId: String; sAudioCodecList: String; nAudioFlowType: Integer; nVideoFlowType: Integer; nTimeout: Integer): Boolean;
  begin
    Result := Boolean(Inherited RefreshCallSession(nSessionId, nChannelId, sCallerName, sCallerId, sAudioCodecList, nAudioFlowType, nVideoFlowType, nTimeout));
  end;

  function TVaxServerCOM.GetCallCount(): Integer;
  begin
      Result := Integer(Inherited GetCallCount());
  end;

  function TVaxServerCOM.AddUserRouteUID(sUserName: String; sRouteUID: String): Boolean;
  begin
      Result := Boolean(Inherited AddUserRouteUID(sUserName, sRouteUID));
  end;

  function TVaxServerCOM.AddLineRouteUID(sLineName: String; sRouteUID: String; sDialOutPrefix: String): Boolean;
  begin
      Result := Boolean(Inherited AddLineRouteUID(sLineName, sRouteUID, sDialOutPrefix));
  end;

  function TVaxServerCOM.AddRingGroupRouteUID(sGroupName: String; sRouteUID: String): Boolean;
  begin
      Result := Boolean(Inherited AddRingGroupRouteUID(sGroupName, sRouteUID));
  end;

  function TVaxServerCOM.AddCallPickUpGroupRouteUID(sRouteUID: String): Boolean;
  begin
      Result := Boolean(Inherited AddCallPickUpGroupRouteUID(sRouteUID));
  end;

  function TVaxServerCOM.AddQueueRouteUID(sQueueName: String; sRouteUID: String): Boolean;
  begin
      Result := Boolean(Inherited AddQueueRouteUID(sQueueName, sRouteUID));
  end;

  function TVaxServerCOM.AddCallParkRouteUID(sRouteUID: String): Boolean;
  begin
      Result := Boolean(Inherited AddCallParkRouteUID(sRouteUID));
  end;

  function TVaxServerCOM.AddConferenceRoomRouteUID(sRoomName: String; sRouteUID: String): Boolean;
  begin
      Result := Boolean(Inherited AddConferenceRoomRouteUID(sRoomName, sRouteUID));
  end;

  function TVaxServerCOM.AddStealthListenRouteUID(sRouteUID: String): Boolean;
  begin
      Result := Boolean(Inherited AddStealthListenRouteUID(sRouteUID));
  end;

  procedure TVaxServerCOM.RemoveRouteUID(sRouteUID: String);
  begin
      Inherited RemoveRouteUID(sRouteUID);
  end;

  function TVaxServerCOM.SendAudioPCM(nSessionId: Integer; nChannelId: Integer; pDataPCM: PByte; nSizePCM: Integer; nTypePCM: Integer): Boolean;
  begin
    Result := Boolean(Inherited SendAudioPCM(nSessionId, nChannelId, Int64(pDataPCM), nSizePCM, nTypePCM));
  end;

  function TVaxServerCOM.AccessAudioPCM(nSessionId: Integer; nChannelId: Integer; sPipeName: String; nAccessType: Integer): Boolean;
  begin
    Result := Boolean(Inherited AccessAudioPCM(nSessionId, nChannelId, sPipeName, nAccessType));
  end;

  function TVaxServerCOM.ActivatePushSIP(bActivate: Boolean; nWaitSeconds: Integer): Boolean;
  begin
    Result := Boolean(Inherited ActivatePushSIP(bActivate, nWaitSeconds));
  end;

  function TVaxServerCOM.SetUserPushSIP(sUserName: String; nProviderPN: Integer; sProjectPN: String; sDevicePN: String): Boolean;
  begin
    Result := Boolean(Inherited SetUserPushSIP(sUserName, nProviderPN, sProjectPN, sDevicePN));
  end;

  function TVaxServerCOM.AttachRegister(nRegId: Integer; sUserName: String): Boolean;
  begin
    Result := Boolean(Inherited AttachRegister(nRegId, sUserName));
  end;

  function TVaxServerCOM.RecordWaveSetCacheSize(nCacheSize: Integer): Boolean;
  begin
    Result := Boolean(Inherited RecordWaveSetCacheSize(nCacheSize));
  end;

  function TVaxServerCOM.SendReqHoldCall(nSessionId: Integer; nChannelId: Integer): Boolean;
  begin
    Result := Boolean(Inherited SendReqHoldCall(nSessionId, nChannelId));
  end;

  function TVaxServerCOM.SendReqUnHoldCall(nSessionId: Integer; nChannelId: Integer): Boolean;
  begin
    Result := Boolean(Inherited SendReqUnHoldCall(nSessionId, nChannelId));
  end;

  function TVaxServerCOM.CallSessionAttachCall(nSessionId: Integer; nVoiceTypeId: Integer; nVideoTypeId: Integer; nAttachToSessionId: Integer; nAttachToChannelId: Integer): Boolean;
  begin
    Result := Boolean(Inherited CallSessionAttachCall(nSessionId, nVoiceTypeId, nVideoTypeId, nAttachToSessionId, nAttachToChannelId));
  end;

  procedure TVaxServerCOM.CallSessionDetachCall(nSessionId: Integer; nVoiceTypeId: Integer; nVideoTypeId: Integer);
  begin
    Inherited CallSessionDetachCall(nSessionId, nVoiceTypeId, nVideoTypeId);
  end;

  function TVaxServerCOM.AttackDetectScanSIP(sDomainName: String): Boolean;
  begin
    Result := Boolean(Inherited AttackDetectScanSIP(sDomainName));
  end;

  function TVaxServerCOM.AttackDetectFloodSIP(nReqRecvLimit: Integer): Boolean;
  begin
    Result := Boolean(Inherited AttackDetectFloodSIP(nReqRecvLimit));
  end;

  function TVaxServerCOM.AttackDetectBruteForceSIP(nFailureCount: Integer; nFailureInterval: Integer): Boolean;
  begin
    Result := Boolean(Inherited AttackDetectBruteForceSIP(nFailureCount, nFailureInterval));
  end;

  function TVaxServerCOM.DetectStartVAD(nSessionId: Integer; nChannelId: Integer; nAudioLevelVU: Integer; nSilenceLengthPCM: Integer; nSilenceCountPCM: Integer; nAnalysisLengthPCM: Integer; nExpiryLengthPCM: Integer; nProcessLengthPCM: Integer; nDetectType: Integer): Boolean;
  begin
    Result := Boolean(Inherited DetectStartVAD(nSessionId, nChannelId, nAudioLevelVU, nSilenceLengthPCM, nSilenceCountPCM, nAnalysisLengthPCM, nExpiryLengthPCM, nProcessLengthPCM, nDetectType));
  end;

  procedure TVaxServerCOM.DetectStopVAD(nSessionId: Integer; nChannelId: Integer);
  begin
    Inherited DetectStopVAD(nSessionId, nChannelId);
  end;

  //////////////////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////////////

  procedure TVaxServerCOM.InvokeEvent(DispID: LongInt; var Params: TVariantArray);

  begin
  case DispID of

    -1: Exit;  // DISPID_UNKNOWN

   1: OnRegisterUser(Params[0] {const WideString},
                     Params[1] {const WideString},
                     Params[2] {const WideString},
                     Params[3] {const WideString},
                     Params[4] {Integer},
                     Params[5] {Integer});

    2: OnRegisterUserSuccess(Params[0] {const WideString},
                             Params[1] {const WideString},
                             Params[2] {Integer},
                             Params[3] {Integer});

    3: OnRegisterUserFailed(Params[0] {const WideString},
                            Params[1] {const WideString},
                            Params[2] {Integer},
                            Params[3] {Integer});

    4: OnUnRegisterUser(Params[0] {const WideString});

    5: OnIncomingCall(Params[0] {Integer},
                      Params[1] {const WideString},
                      Params[2] {const WideString},
                      Params[3] {const WideString},
                      Params[4] {Integer},
                      Params[5] {const WideString},
                      Params[6] {const WideString},
                      Params[7] {Integer},
                      Params[8] {const WideString},
                      Params[9] {const WideString},
                      Params[10] {const WideString},
                      Params[11] {Integer});

    6: OnCallSessionFailed(Params[0] {Integer},
                           Params[1] {Integer},
                           Params[2] {Integer},
                           Params[3] {const WideString},
                           Params[4] {const WideString});

    7: OnCallSessionConnected(Params[0] {Integer});

    8: OnCallSessionClosed(Params[0] {Integer},
                           Params[1] {Integer},
                           Params[2] {Integer});

    9: OnCallSessionOnHold(Params[0] {Integer},
                           Params[1] {Integer});

    10: OnCallSessionOffHold(Params[0] {Integer},
                             Params[1] {Integer});

    11: OnCallSessionTransferBlind(Params[0] {Integer},
                                   Params[1] {Integer},
                                   Params[2] {const WideString},
                                   Params[3] {const WideString},
                                   Params[4] {const WideString},
                                   Params[5] {const WideString},
                                   Params[6] {Integer},
                                   Params[7] {const WideString});

    12: OnCallSessionTransferConsult(Params[0] {Integer},
                                     Params[1] {Integer},
                                     Params[2] {Integer},
                                     Params[3] {Integer},
                                     Params[4] {const WideString},
                                     Params[5] {const WideString},
                                     Params[6] {const WideString});

    13: OnLineRegisterTrying(Params[0] {const WideString});

    14: OnLineRegisterFailed(Params[0] {const WideString},
                             Params[1] {Integer},
                             Params[2] {const WideString});

    15: OnLineRegisterSuccess(Params[0] {const WideString});

    16: OnLineUnRegisterTrying(Params[0] {const WideString});

    17: OnLineUnRegisterFailed(Params[0] {const WideString},
                               Params[1] {Integer},
                               Params[2] {const WideString});

    18: OnLineUnRegisterSuccess(Params[0] {const WideString});

    19: OnChatMessageText(Params[0] {Integer},
                          Params[1] {const WideString},
                          Params[2] {const WideString},
                          Params[3] {const WideString},
                          Params[4] {Integer},
                          Params[5] {const WideString},
                          Params[6] {const WideString},
                          Params[7] {Integer});

    20: OnChatMessageTyping(Params[0] {Integer},
                            Params[1] {const WideString},
                            Params[2] {const WideString},
                            Params[3] {WordBool},
                            Params[4] {Integer},
                            Params[5] {const WideString},
                            Params[6] {const WideString},
                            Params[7] {Integer});

    21: OnChatStatusSubscribe(Params[0] {Integer},
                              Params[1] {const WideString},
                              Params[2] {const WideString},
                              Params[3] {Integer},
                              Params[4] {const WideString},
                              Params[5] {const WideString},
                              Params[6] {Integer});

    22: OnChatMessageSuccess(Params[0] {Integer});

    23: OnChatMessageFailed(Params[0] {Integer},
                            Params[1] {Integer},
                            Params[2] {const WideString});

    24: OnChatMessageTimeout(Params[0] {Integer});

    25: OnOutgoingDiagnosticLog(Params[0] {const WideString},
                                Params[1] {const WideString},
                                Params[2] {Integer});

    26: OnIncomingDiagnosticLog(Params[0] {const WideString},
                                Params[1] {const WideString},
                                Params[2] {Integer});

    27: OnDetectedDigitDTMF(Params[0] {Integer},
                            Params[1] {Integer},
                            Params[2] {const WideString},
                            Params[3] {Integer});

    28: OnVaxTeleTick(Params[0] {Integer});

    29: OnSendTimeoutVM(Params[0] {Integer});

    30: OnSendSuccessVM(Params[0] {Integer});

    31: OnCallSessionDialToneStarted(Params[0] {Integer},
                                   Params[1] {Integer},
                                   Params[2] {Integer});

    32: OnCallSessionDialToneEnded(Params[0] {Integer},
                                  Params[1] {Integer},
                                  Params[2] {Integer});

    33: OnCallSessionPlayWaveDone(Params[0] {Integer},
                                  Params[1] {Integer},
                                  Params[2] {Integer});

    34: OnConferenceRoomPlayWaveDone(Params[0] {const WideString},
                                     Params[1] {Integer});

    35: OnCallSessionConnecting(Params[0] {Integer},
                                Params[1] {Integer},
                                Params[2] {Integer},
                                Params[3] {const WideString});

    36: OnCallSessionLost(Params[0] {Integer},
                          Params[1] {Integer});

    37: OnCallSessionHangup(Params[0] {Integer},
                            Params[1] {Integer});

    38: OnCallSessionTimeout(Params[0] {Integer},
                             Params[1] {Integer});

    39: OnCallSessionCancelled(Params[0] {Integer});

    40: OnCallSessionTransfering(Params[0] {Integer},
                                 Params[1] {Integer},
                                 Params[2] {Integer},
                                 Params[3] {Integer},
                                 Params[4] {const WideString});

    41: OnCallSessionTransferFailed(Params[0] {Integer},
                                    Params[1] {Integer},
                                    Params[2] {Integer},
                                    Params[3] {Integer},
                                    Params[4] {const WideString});

    42: OnCallSessionTransferTimeout(Params[0] {Integer},
                                     Params[1] {Integer},
                                     Params[2] {Integer});

    43: OnCallSessionTransfered(Params[0] {Integer},
                                Params[1] {Integer});

    44: OnCallSessionCreated(Params[0] {Integer},
                             Params[1] {Integer});

    45: OnCallSessionDetectedAMD(Params[0] {Integer},
                                 Params[1] {Integer},
                                 Params[2] {WordBool});

    46: OnBusyLampSubscribe(Params[0] {Integer},
                            Params[1] {const WideString},
                            Params[2] {const WideString},
                            Params[3] {const WideString},
                            Params[4] {Integer});

    47: OnBusyLampUnSubscribe(Params[0] {Integer},
                              Params[1] {const WideString},
                              Params[2] {const WideString},
                              Params[3] {const WideString},
                              Params[4] {Integer});

    48: OnBusyLampSubscribeSuccess(Params[0] {Integer},
                                   Params[1] {const WideString});

    49: OnBusyLampSubscribeFailed(Params[0] {Integer},
                                  Params[1] {const WideString});

    50: OnCallSessionRecordedWaveREC(Params[0] {Integer},
                                 Params[1] {Integer},
                                 PByte(Int64(Params[2])) {Int64},
                                 Params[3] {Integer},
                                 Params[4] {Integer});

    51: OnConferenceRoomRecordedWaveREC(Params[0] {const WideString},
                                    PByte(Int64(Params[1])) {Int64},
                                    Params[2] {Integer},
                                    Params[3] {Integer});

    52: OnVaxErrorLog(Params[0] {const WideString},
                      Params[1] {Integer},
                      Params[2] {const WideString});

    53: OnAddCallSessionToQueueSuccess(Params[0] {const WideString},
                                       Params[1] {Integer});

    54: OnAddCallSessionToQueueFailed(Params[0] {const WideString},
                                      Params[1] {Integer});

    55: OnVaxLicenseChannel(Params[0] {Integer},
                            Params[1] {Integer});

    56: OnAddCallSessionToRingGroupSuccess(Params[0] {const WideString},
                                           Params[1] {Integer});

    57: OnAddCallSessionToRingGroupFailed(Params[0] {const WideString},
                                          Params[1] {Integer});

    58: OnSendReqTransferCallTimeout(Params[0] {Integer},
                                     Params[1] {Integer});

    59: OnSendReqTransferCallAccepted(Params[0] {Integer},
                                      Params[1] {Integer});

    60: OnSendReqTransferCallFailed(Params[0] {Integer},
                                    Params[1] {Integer},
                                    Params[2] {Integer},
                                    Params[3] {const WideString});

    61: OnQualityReportPUBLISH(Params[0] {const WideString},
                               Params[1] {const WideString},
                               Params[2] {const WideString},
                               Params[3] {Integer});

    62: OnBusyLampSendStatus(Params[0] {const WideString},
                             Params[1] {const WideString},
                             Params[2] {Integer});

    63: OnServerConnectingREC(Params[0] {Integer},
                              Params[1] {Integer},
                              Params[2] {Integer},
                              Params[3] {const WideString});

    64: OnServerConnectedREC(Params[0] {Integer},
                             Params[1] {Integer});

    65: OnServerFailedREC(Params[0] {Integer},
                          Params[1] {Integer},
                          Params[2] {Integer},
                          Params[3] {const WideString});

    66: OnServerTimeoutREC(Params[0] {Integer},
                           Params[1] {Integer});

    67: OnServerHungupREC(Params[0] {Integer},
                          Params[1] {Integer});

    68: OnQueuePlayWaveStarted(Params[0] {Integer},
                             Params[1] {const WideString},
                             Params[2] {Integer});

    69: OnQueuePlayWaveEnded(Params[0] {Integer},
                            Params[1] {const WideString},
                            Params[2] {Integer});

    70: OnQueueAgentConnectStarted(Params[0] {const WideString},
                                   Params[1] {const WideString},
                                   Params[2] {Integer});

    71: OnQueueAgentConnectTrying(Params[0] {const WideString},
                                  Params[1] {const WideString},
                                  Params[2] {Integer},
                                  Params[3] {Integer},
                                  Params[4] {const WideString});

    72: OnQueueAgentConnectFailed(Params[0] {const WideString},
                                  Params[1] {const WideString},
                                  Params[2] {Integer},
                                  Params[3] {Integer},
                                  Params[4] {const WideString});

    73: OnQueueAgentConnectTimeout(Params[0] {const WideString},
                                   Params[1] {const WideString},
                                   Params[2] {Integer});

    74: OnQueueAgentConnectSuccess(Params[0] {const WideString},
                                   Params[1] {const WideString},
                                   Params[2] {Integer});

    75: OnChatStatusSendSubscribeSuccess(Params[0] {Integer});

    76: OnChatStatusSendSubscribeFailed(Params[0] {Integer},
                                        Params[1] {Integer},
                                        Params[2] {const WideString});

    77: OnSendNotifyMsgSuccess(Params[0] {Integer});

    78: OnSendNotifyMsgFailed(Params[0] {Integer},
                              Params[1] {Integer},
                              Params[2] {const WideString});

    79: OnCallSessionErrorLog(Params[0] {Integer},
                              Params[1] {Integer},
                              Params[2] {Integer},
                              Params[3] {const WideString});

    80: OnCallParkPlayWaveStarted(Params[0] {Integer},
                                Params[1] {Integer});

    81: OnCallParkPlayWaveStop(Params[0] {Integer},
                               Params[1] {Integer});


    82: OnCallSessionAccessAudioPCM(Params[0] {Integer},
                                    Params[1] {Integer},
                                    Params[2] {Integer},
                                    PByte(Int64(Params[3])) {Int64},
                                    Params[4] {Integer},
                                    Params[5] {Integer});

    83: OnStealthListenerAttached(Params[0] {Integer},
                                  Params[1] {Integer},
                                  Params[2] {Integer},
                                  Params[3] {Integer});

    84: OnCallSessionPushSIP(Params[0] {Integer},
                               Params[1] {Integer},
                               Params[2] {Integer},
                               Params[3] {Integer},
                               Params[4] {Integer},
                               Params[5] {Integer},
                               Params[6] {Integer});

    85: OnRegisterUserPushSIP(Params[0] {Integer},
                               Params[1] {Integer},
                               Params[2] {Integer},
                               Params[3] {Integer});

    86: OnSendReqHoldCallSuccess(Params[0] {Integer}, // nSessionId
                                 Params[1] {Integer}); // nChannelId

    87: OnSendReqHoldCallTrying(Params[0] {Integer}, // nSessionId
                                Params[1] {Integer}); // nChannelId

    88: OnSendReqHoldCallTimeout(Params[0] {Integer}, // nSessionId
                                Params[1] {Integer}); // nChannelId

    89: OnSendReqHoldCallFailed(Params[0] {Integer}, // nSessionId
                                Params[1] {Integer}, // nChannelId
                                Params[2] {Integer}, // nStatusCode
                                Params[3] {String});  // sReasonPhrase

    90: OnSendReqUnHoldCallSuccess(Params[0] {Integer}, // nSessionId
                                   Params[1] {Integer}); // nChannelId

    91: OnSendReqUnHoldCallTrying(Params[0] {Integer}, // nSessionId
                                  Params[1] {Integer}); // nChannelId

    92: OnSendReqUnHoldCallTimeout(Params[0] {Integer}, // nSessionId
                                  Params[1] {Integer}); // nChannelId

    93: OnSendReqUnHoldCallFailed(Params[0] {Integer}, // nSessionId
                                  Params[1] {Integer}, // nChannelId
                                  Params[2] {Integer}, // nStatusCode
                                  Params[3] {String});  // sReasonPhrase

    94: OnAttackDetectedScanSIP(Params[0] {String},    // sReqMethod
                                Params[1] {String},    // sAddrIP
                                Params[2] {Integer},   // nAddrPort
                                Params[3] {Integer});  // nAddrType

    95: OnAttackDetectedFloodSIP(Params[0] {String},    // sAddrIP
                                 Params[1] {Integer},   // nAddrPort
                                 Params[2] {Integer});  // nAddrType

    96: OnAttackDetectedBruteForceSIP(Params[0] {String},    // sReqMethod
                                      Params[1] {Integer},   // nAuthFailureCount
                                      Params[2] {String},    // sAddrIP
                                      Params[3] {Integer},   // nAddrPort
                                      Params[4] {Integer});  // nAddrType

    97: OnCallSessionMediaDetectStartedVAD(Params[0] {Integer},
                                             Params[1] {Integer});

    98: OnCallSessionMediaDetectCompletedVAD(Params[0] {Integer},
                                             Params[1] {Integer},
                                             PByte(Int64(Params[2])) {Int64},
                                             Params[3] {Integer},
                                             Params[4] {Integer});

    99: OnCallSessionMediaDetectExpiredVAD(Params[0] {Integer},
                                             Params[1] {Integer});

  end; {case DispID}
end;

  procedure TVaxServerCOM.OnLineRegisterTrying(sLineName: String);
  begin
  end;
  procedure TVaxServerCOM.OnLineRegisterFailed(sLineName: String; nStatusCode: Integer; sReasonPhrase: String);
  begin
  end;
  procedure TVaxServerCOM.OnLineRegisterSuccess(sLineName: String);
  begin
  end;
  procedure TVaxServerCOM.OnLineUnRegisterTrying(sLineName: String);
  begin
  end;
  procedure TVaxServerCOM.OnLineUnRegisterFailed(sLineName: String; nStatusCode: Integer; sReasonPhrase: String);
  begin
  end;
  procedure TVaxServerCOM.OnLineUnRegisterSuccess(sLineName: String);
  begin
  end;

  procedure TVaxServerCOM.OnUnRegisterUser(sUserLogin: String);
  begin
  end;

  procedure TVaxServerCOM.OnRegisterUser(sUserLogin: String; sDomain: String; sUserAgentName: String; sFromIP: String; nFromPort: Integer; nRegId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnRegisterUserSuccess(sUserLogin: String; sFromIP: String; nFromPort: Integer; nRegId: Integer);
  begin
  end;
  procedure TVaxServerCOM.OnRegisterUserFailed(sUserLogin: String; sFromIP: String; nFromPort: Integer; nRegId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnChatMessageText(nChatMsgId: Integer; sMsgFrom: String; sMsgTo: String; sMsgText: String; nFromPeerType: Integer; sFromPeerName: String; sFromIP: String; nFromPort: Integer);
  begin
  end;
  procedure TVaxServerCOM.OnChatMessageTyping(nChatMsgId: Integer; sMsgFrom: String; sMsgTo: String; bIsTypingStart: Boolean; nFromPeerType: Integer; sFromPeerName: String; sFromIP: String; nFromPort: Integer);
  begin
  end;
  procedure TVaxServerCOM.OnChatStatusSubscribe(nSubscrbId: Integer; sMsgFrom: String; sMsgTo: String; nFromPeerType: Integer; sFromPeerName: String; sFromIP: String; nFromPort: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnChatMessageSuccess(nChatMsgId: Integer);
  begin
  end;
  procedure TVaxServerCOM.OnChatMessageFailed(nChatMsgId: Integer; nStatusCode: Integer; sReasonPhrase: String);
  begin
  end;
  procedure TVaxServerCOM.OnChatMessageTimeout(nChatMsgId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnIncomingCall(nSessionId: Integer; sCallerName: String; sCallerId: String; sDialNo: String; nFromPeerType: Integer; sFromPeerName: String; sRouteUID: String; nRouteType: Integer; sRouteName: String; sUserAgentName: String; sFromIP: String; nFromPort: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionFailed(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String; sContact: String);
  begin
  end;
  procedure TVaxServerCOM.OnCallSessionConnected(nSessionId: Integer);
  begin
  end;
  procedure TVaxServerCOM.OnCallSessionClosed(nSessionId: Integer; nChannelId: Integer; nReasonCode: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionConnecting(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String);
  begin
  end;
  procedure TVaxServerCOM.OnCallSessionLost(nSessionId: Integer; nChannelId: Integer);
  begin
  end;
  procedure TVaxServerCOM.OnCallSessionHangup(nSessionId: Integer; nChannelId: Integer);
  begin
  end;
  procedure TVaxServerCOM.OnCallSessionTimeout(nSessionId: Integer; nChannelId: Integer);
  begin
  end;
  procedure TVaxServerCOM.OnCallSessionCancelled(nSessionId: Integer);
  begin
  end;


  procedure TVaxServerCOM.OnCallSessionOnHold(nSessionId: Integer; nChannelId: Integer);
  begin
  end;
  procedure TVaxServerCOM.OnCallSessionOffHold(nSessionId: Integer; nChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionTransferBlind(nTransfererSessionId: Integer; nTransfererChannelId: Integer; sTransferer: String; sTransferee: String; sTransferTo: String; sRouteUID: String; nRouteType: Integer; sRouteName: String);
  begin
  end;
  procedure TVaxServerCOM.OnCallSessionTransferConsult(nTransfererSessionId: Integer; nTransfererChannelId: Integer; nTransferToSessionId: Integer; nTransferToChannelId: Integer; sTransferer: String; sTransferee: String; sTransferTo: String);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionTransfering(nSessionId: Integer; nTransferType: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionTransferFailed(nSessionId: Integer; nTransferType: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionTransferTimeout(nSessionId: Integer; nTransferType: Integer; nChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionTransfered(nSessionId: Integer; nTransferType: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnDetectedDigitDTMF(nSessionId: Integer; nChannelId: Integer; sDigitDTMF: String; nTypeDTMF: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnOutgoingDiagnosticLog(sMsgSIP: String; sToIP: String; nToPort: Integer);
  begin
  end;
  procedure TVaxServerCOM.OnIncomingDiagnosticLog(sMsgSIP: String; sFromIP: String; nFromPort: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnVaxTeleTick(nTickId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnSendTimeoutVM(nMsgIdVM: Integer);
  begin
  end;
  procedure TVaxServerCOM.OnSendSuccessVM(nMsgIdVM: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionDialToneStarted(nSessionId: Integer; nChannelId: Integer; nWaveId: Integer);
  begin
  end;
  procedure TVaxServerCOM.OnCallSessionDialToneEnded(nSessionId: Integer; nChannelId: Integer; nWaveId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnBusyLampSubscribe(nSubscrbId: Integer; sUserName: String; sToUserName: String; sFromIP: String; nFromPort: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnBusyLampUnSubscribe(nSubscrbId: Integer; sUserName: String; sToUserName: String; sFromIP: String; nFromPort: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnBusyLampSubscribeSuccess(nSubscrbId: Integer; sUserName: String);
  begin
  end;

  procedure TVaxServerCOM.OnBusyLampSubscribeFailed(nSubscrbId: Integer; UserName: String);
  begin
  end;

  procedure TVaxServerCOM.OnBusyLampSendStatus(sFromUserName: String; sToUserName: String; nStateId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionPlayWaveDone(nSessionId: Integer; nChannelId: Integer; nWaveId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnConferenceRoomPlayWaveDone(sRoomName: String; nWaveId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionCreated(nSessionId: Integer; nReasonCode: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionDetectedAMD(nSessionId: Integer; nChannelId: Integer; bIsHuman: Boolean);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionRecordedWaveREC(nSessionId: Integer; nChannelId: Integer; pDataREC: PByte; nSizeREC: Integer; nTypeREC: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnConferenceRoomRecordedWaveREC(sRoomName: String; pDataREC: PByte; nSizeREC: Integer; nTypeREC: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnVaxErrorLog(sFuncName: String; nErrorCode: Integer; sErrorMsg: String);
  begin
  end;

  procedure TVaxServerCOM.OnAddCallSessionToQueueSuccess(sQueueName: String; nSessionId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnAddCallSessionToQueueFailed(sQueueName: String; nSessionId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnVaxLicenseChannel(nTotalChannels: Integer; nUsedChannels: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnAddCallSessionToRingGroupSuccess(sGroupName: String; nSessionId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnAddCallSessionToRingGroupFailed(sGroupName: String; nSessionId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnSendReqTransferCallTimeout(nSessionId: Integer; nChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnSendReqTransferCallAccepted(nSessionId: Integer; nChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnSendReqTransferCallFailed(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String);
  begin
  end;

  procedure TVaxServerCOM.OnQualityReportPUBLISH(sMsgSIP: String; sMsgSDP: String; sFromIP: String; nFromPort: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnServerConnectingREC(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String);
  begin
  end;

  procedure TVaxServerCOM.OnServerConnectedREC(nSessionId: Integer; nChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnServerFailedREC(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: String);
  begin
  end;

  procedure TVaxServerCOM.OnServerTimeoutREC(nSessionId: Integer; nChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnServerHungupREC(nSessionId: Integer; nChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnQueuePlayWaveStarted(nEventType: Integer; sQueueName: String; nSessionId: Integer);
  begin

  end;

  procedure TVaxServerCOM.OnQueuePlayWaveEnded(nEventType: Integer; sQueueName: String; nSessionId: Integer);
  begin

  end;

  procedure TVaxServerCOM.OnQueueAgentConnectStarted(sQueueName: String; sAgentName: String; nSessionId: Integer);
  begin

  end;

  procedure TVaxServerCOM.OnQueueAgentConnectTrying(sQueueName: String; sAgentName: String; nSessionId: Integer; nStatusCode: Integer; sReasonPhrase: String);
  begin

  end;

  procedure TVaxServerCOM.OnQueueAgentConnectFailed(sQueueName: String; sAgentName: String; nSessionId: Integer; nStatusCode: Integer; sReasonPhrase: String);
  begin

  end;

  procedure TVaxServerCOM.OnQueueAgentConnectTimeout(sQueueName: String; sAgentName: String; nSessionId: Integer);
  begin

  end;

  procedure TVaxServerCOM.OnQueueAgentConnectSuccess(sQueueName: String; sAgentName: String; nSessionId: Integer);
  begin

  end;

  procedure TVaxServerCOM.OnChatStatusSendSubscribeSuccess(nSubscrbId: Integer);
  begin

  end;

  procedure TVaxServerCOM.OnChatStatusSendSubscribeFailed(nSubscrbId: Integer; nStatusCode: Integer; sReasonPhrase: String);
  begin

  end;

  procedure TVaxServerCOM.OnSendNotifyMsgSuccess(nMsgId: Integer);
  begin

  end;

  procedure TVaxServerCOM.OnSendNotifyMsgFailed(nMsgId: Integer; nStatusCode: Integer; sReasonPhrase: String);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionErrorLog(nSessionId: Integer; nChannelId: Integer; nErrorCode: Integer; sErrorMsg: String);
  begin
  end;

  procedure TVaxServerCOM.OnCallParkPlayWaveStarted(nSessionId: Integer; nChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnCallParkPlayWaveStop(nSessionId: Integer; nChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionAccessAudioPCM(nSessionId: Integer; nChannelId: Integer; nAccessType: Integer; pDataPCM: PByte; nSizePCM: Integer; nTypePCM: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnStealthListenerAttached(nAttachType: Integer; nStealthSessionId: Integer; nAttachSessionId: Integer; nAttachChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionPushSIP(nSessionId: Integer; nChannelId: Integer; sCallerName: String; sCallerId: String; nProviderPN: Integer; sProjectPN: String; sDevicePN: String);
  begin
  end;

  procedure TVaxServerCOM.OnRegisterUserPushSIP(sUserName: String; nProviderPN: Integer; sProjectPN: String; sDevicePN: String);
  begin
  end;

  procedure TVaxServerCOM.OnSendReqHoldCallSuccess(nSessionId: Integer; nChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnSendReqHoldCallTrying(nSessionId: Integer; nChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnSendReqHoldCallTimeout(nSessionId: Integer; nChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnSendReqHoldCallFailed(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: WideString);
  begin
  end;

  procedure TVaxServerCOM.OnSendReqUnHoldCallSuccess(nSessionId: Integer; nChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnSendReqUnHoldCallTrying(nSessionId: Integer; nChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnSendReqUnHoldCallTimeout(nSessionId: Integer; nChannelId: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnSendReqUnHoldCallFailed(nSessionId: Integer; nChannelId: Integer; nStatusCode: Integer; sReasonPhrase: WideString);
  begin
  end;

  procedure TVaxServerCOM.OnAttackDetectedScanSIP(sReqMethod: Integer; sAddrIP: WideString; nAddrPort: Integer; nAddrType: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnAttackDetectedFloodSIP(sAddrIP: WideString; nAddrPort: Integer; nAddrType: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnAttackDetectedBruteForceSIP(sReqMethod: Integer; nAuthFailureCount: Integer; sAddrIP: WideString; nAddrPort: Integer; nAddrType: Integer);
  begin
  end;

  procedure TVaxServerCOM.OnCallSessionMediaDetectStartedVAD(nSessionId: Integer; nChannelId: Integer);
  begin

  end;

  procedure TVaxServerCOM.OnCallSessionMediaDetectCompletedVAD(nSessionId: Integer; nChannelId: Integer; pDataPCM: PByte; nSizePCM: Integer; nTypePCM: Integer);
  begin

  end;

  procedure TVaxServerCOM.OnCallSessionMediaDetectExpiredVAD(nSessionId: Integer; nChannelId: Integer);
  begin

  end;

end.

