unit GeneralDlg;

Interface

uses

  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.StdCtrls, Vcl.ExtCtrls,

  StoreCOMM,
  VaxUser,
  VaxServerSIP;

type TGeneralForm = class(TForm)

  GroupBox1: TGroupBox;
  GroupBox2: TGroupBox;
  GroupBox3: TGroupBox;
  GroupBoxStatistics: TGroupBox;

  Label2: TLabel;
  Label4: TLabel;
  Label5: TLabel;

  EditListenPort: TEdit;
  EditPlayWaveHold: TEdit;
  EditPlayWaveDialTone: TEdit;
  BtnStartServerSIP: TButton;

  LabelServerStatus: TLabel;
  LabelTotalCalls: TLabel;
  LabelTotalUsers: TLabel;

  TimerGeneral: TTimer;
  LabelTextTotalUsers: TLabel;
  LabelTextTotalCalls: TLabel;

  Label1: TLabel;
  EditPlayWaveCallParking: TEdit;

  procedure TimerGeneral_Tick(Sender: TObject);
  procedure BtnStartServerSIPClick(Sender: TObject);

  public
  constructor Create(AOwner : TComponent); reintroduce; overload;
  procedure OnSetActive();

  private
  procedure UpdateStats();

  private
  const STATUS_MSG_SERVER_RUNNING = 'SIP SERVER IS RUNNING.';
  const STATUS_MSG_SERVER_NOT_RUNNING = 'SIP SERVER IS NOT RUNNING.';

  const START_BUTTON_TITLE = 'Start';
  const STOP_BUTTON_TITLE = 'Stop';


end;

var

  GeneralForm: TGeneralForm;
  m_bServerRunning: Boolean;


implementation

{$R *.dfm}

    constructor TGeneralForm.Create(AOwner: TComponent);
    var
      nListenPortSIP: Integer;
      sMusicHold, sMusicDialTone, sMusicCallPark: string;
    begin
      inherited Create(AOwner);

      TStoreCOMM.GetListenPortSIP(nListenPortSIP);
      EditListenPort.Text := IntToStr(nListenPortSIP);

      TStoreCOMM.GetMusicFiles(sMusicHold, sMusicDialTone, sMusicCallPark);

      EditPlayWaveHold.Text := sMusicHold;
      EditPlayWaveDialTone.Text := sMusicDialTone;
      EditPlayWaveCallParking.Text := sMusicCallPark;

      LabelServerStatus.Caption := STATUS_MSG_SERVER_NOT_RUNNING;
      m_bServerRunning := False;

    end;

    procedure TGeneralForm.BtnStartServerSIPClick(Sender: TObject);
    var
      nListenPort: Integer;
      bResult: Boolean;
    begin

      if (m_bServerRunning = True)  Then
      Begin
        TVaxServerSIP.mVaxSIP.StopServer();
        TimerGeneral.Enabled := False;

        LabelServerStatus.Caption := STATUS_MSG_SERVER_NOT_RUNNING;
        BtnStartServerSIP.Caption := START_BUTTON_TITLE;

        m_bServerRunning := False;
        Exit();
      End;

      nListenPort := StrToInt(EditListenPort.Text);
      bResult := TVaxServerSIP.mVaxSIP.StartServer(nListenPort);

      if(bResult = False) then
      begin
        LabelServerStatus.Caption := AnsiUpperCase('UNABLE TO START SIP SERVER (SEE STATUS LOG).');
        Exit();
      end;

      TVaxServerSIP.mVaxSIP.LoadMusicFiles(EditPlayWaveHold.Text, EditPlayWaveDialTone.Text, EditPlayWaveCallParking.Text);
      TimerGeneral.Enabled := True;

      LabelServerStatus.Caption := STATUS_MSG_SERVER_RUNNING;
      BtnStartServerSIP.Caption := STOP_BUTTON_TITLE;

      m_bServerRunning := true;

    end;

    procedure TGeneralForm.OnSetActive();
    begin
      //
    end;

    procedure TGeneralForm.TimerGeneral_Tick(Sender: TObject);
    begin
      UpdateStats();
    end;

    procedure TGeneralForm.UpdateStats();
    begin

      LabelTotalCalls.Caption := IntToStr(TVaxServerSIP.mVaxSIP.GetCallCount());
      LabelTotalUsers.Caption := IntToStr(TVaxUser.GetRegisteredUserCount());

    end;

end.
