unit MainFormDlg;

interface

uses
  Winapi.Windows, Winapi.Messages,
  System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.ComCtrls, Vcl.OleServer,

  GeneralDlg,
  AddLoginDlg,
  AddLineDlg,
  AddRoomDlg,

  QueueDlg,
  RingGroupDlg,
  CallPickUpDlg,

  StatusLogDlg,
  SIPRecDlg,

  VaxServerSIP;

Type TMainForm = class(TForm)

  TabPageControlMain: TPageControl;
  TabPageGeneral: TTabSheet;
  TabPageLogin: TTabSheet;
  TabPageLine: TTabSheet;
  TabPageRoom: TTabSheet;

  TabPageQueue: TTabSheet;
  TabPageRingGroup: TTabSheet;
  TabPageCallPickUp: TTabSheet;

  TabPageStatusLog: TTabSheet;
  TabPageSIPREC: TTabSheet;

  procedure OnCreate(Sender: TObject);
  procedure OnMainTab_Click(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  procedure OnClose(Sender: TObject; var Action: TCloseAction);

  private

  m_objGeneralDlg : TGeneralForm;
  m_objAddLoginDlg : TAddLoginForm;
  m_objAddLineDlg : TAddLineForm;

  m_objAddRoomDlg : TAddRoomForm;

  m_objQueueDlg : TQueueForm;
  m_objRingGroupDlg : TRingGroupForm;
  m_objPickUpDlg : TCallPickUpForm;

  m_objRecDlgSIP : TSIPRecForm;
  m_objStatusLogDlg : TStatusLogForm;

  private
  m_pVaxTeleSIP : TVaxServerSIP;

end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

  procedure TMainForm.OnClose(Sender: TObject; var Action: TCloseAction);
  begin
    m_pVaxTeleSIP.StopServer();
  end;

  procedure TMainForm.OnCreate(Sender: TObject);
  begin

    m_pVaxTeleSIP := TVaxServerSIP.Create();

    m_objGeneralDlg := TGeneralForm.Create(TabPageGeneral);
    m_objGeneralDlg.Parent := TabPageGeneral;
    m_objGeneralDlg.Align := alClient;
    m_objGeneralDlg.Visible := true;

    m_objAddLoginDlg := TAddLoginForm.Create(TabPageLogin);
    m_objAddLoginDlg.Parent := TabPageLogin;
    m_objAddLoginDlg.Align := alClient;
    m_objAddLoginDlg.Visible := true;

    m_objAddLineDlg := TAddLineForm.Create(TabPageLine);
    m_objAddLineDlg.Parent := TabPageLine;
    m_objAddLineDlg.Align := alClient;
    m_objAddLineDlg.Visible := true;

    m_objAddRoomDlg := TAddRoomForm.Create(TabPageRoom);
    m_objAddRoomDlg.Parent := TabPageRoom;
    m_objAddRoomDlg.Align := alClient;
    m_objAddRoomDlg.Visible := true;

    m_objQueueDlg := TQueueForm.Create(TabPageQueue);
    m_objQueueDlg.Parent := TabPageQueue;
    m_objQueueDlg.Align := alClient;
    m_objQueueDlg.Visible := true;

    m_objRingGroupDlg := TRingGroupForm.Create(TabPageRingGroup);
    m_objRingGroupDlg.Parent := TabPageRingGroup;
    m_objRingGroupDlg.Align := alClient;
    m_objRingGroupDlg.Visible := true;

    m_objPickUpDlg := TCallPickUpForm.Create(TabPageCallPickUp);
    m_objPickUpDlg.Parent := TabPageCallPickUp;
    m_objPickUpDlg.Align := alClient;
    m_objPickUpDlg.Visible := true;

    m_objRecDlgSIP := TSIPRecForm.Create(TabPageSIPRec);
    m_objRecDlgSIP.Parent := TabPageSIPRec;
    m_objRecDlgSIP.Align := alClient;
    m_objRecDlgSIP.Visible := true;

    m_objStatusLogDlg := TStatusLogForm.Create(TabPageStatusLog);
    m_objStatusLogDlg.Parent := TabPageStatusLog;
    m_objStatusLogDlg.Align := alClient;
    m_objStatusLogDlg.Visible := true;

    m_pVaxTeleSIP.m_objStatusLogDlg := m_objStatusLogDlg;
    m_pVaxTeleSIP.m_objRecDlgSIP := m_objRecDlgSIP;

  end;

  procedure TMainForm.OnMainTab_Click(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  begin

    if(TabPageControlMain.ActivePage = TabPageControlMain.Pages[0]) then
      m_objGeneralDlg.OnSetActive();

    if TabPageControlMain.ActivePage = TabPageControlMain.Pages[1] then
      m_objAddLoginDlg.OnSetActive();

    if TabPageControlMain.ActivePage = TabPageControlMain.Pages[2] then
      m_objAddLineDlg.OnSetActive();

    if TabPageControlMain.ActivePage = TabPageControlMain.Pages[3] then
      m_objAddRoomDlg.OnSetActive();

    if TabPageControlMain.ActivePage = TabPageControlMain.Pages[4] then
      m_objQueueDlg.OnSetActive();

    if TabPageControlMain.ActivePage = TabPageControlMain.Pages[5] then
      m_objRingGroupDlg.OnSetActive();

    if TabPageControlMain.ActivePage = TabPageControlMain.Pages[6] then
      m_objPickUpDlg.OnSetActive();

    if TabPageControlMain.ActivePage = TabPageControlMain.Pages[7] then
      m_objRecDlgSIP.OnSetActive();

  end;

end.
