﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace ServerSIP
{
    public partial class CallPickupForm : Form
    {
        public CallPickupForm()
        {
            InitializeComponent();
        }

        private void BtnAddCallPickupGroup_Click(object sender, EventArgs e)
        {
            if(ComboPickupGroup.Text == "")
            {
                MessageBox.Show("Please enter pickup group name.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            if(ComboPickupGroup.FindStringExact(ComboPickupGroup.Text) != -1)
            {
                if(MessageBox.Show("Pickup Group already exists, do you want to continue?", "VaxVoIP", MessageBoxButtons.YesNo, MessageBoxIcon.Exclamation) == DialogResult.No)
                {
                    return;
                }
            }

            ArrayList objMemberList = new ArrayList();
            GetMemberNameAll(ref objMemberList);

            if (!cVaxPickUpGroup.AddCallPickUpGroup(ComboPickupGroup.Text, objMemberList))
            {
                MessageBox.Show("Pickup Group couldn't be added.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }
                        
            if(!ComboPickupGroup.Items.Contains(ComboPickupGroup.Text))
                ComboPickupGroup.Items.Add(ComboPickupGroup.Text);

            MessageBox.Show("PickUp Group added/updated successfully.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void BtnRemoveCallPickupGroup_Click(object sender, EventArgs e)
        {
            if(ComboPickupGroup.Text == "" || (!ComboPickupGroup.Items.Contains(ComboPickupGroup.Text)))
                return;
                        
            int nIndex = ComboPickupGroup.FindStringExact(ComboPickupGroup.Text);
            if(nIndex == -1) return;

            cVaxPickUpGroup.RemoveCallPickUpGroup(ComboPickupGroup.Text);
            ComboPickupGroup.Items.RemoveAt(nIndex);

            ClearDlgUI();

            if (ComboPickupGroup.Items.Count > 0)
                ComboPickupGroup.SelectedIndex = 0;

            ShowPickupGroupDetails();

            MessageBox.Show("PickUp Group removed successfully.", "VaxVoIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void BtnClearCallPickupGroup_Click(object sender, EventArgs e)
        {
            ComboPickupGroup.Text = "";
            
            if (ComboMemberName.Items.Count > 0)
                ComboMemberName.SelectedIndex = 0;

            ListBoxMember.Items.Clear();
        }

        private void BtnAddAgent_Click(object sender, EventArgs e)
        {
            if(ListBoxMember.FindStringExact(ComboMemberName.Text) != -1)
            {
                return;
            }

            ListBoxMember.Items.Insert(0, ComboMemberName.Text);
        }

        private void BtnRemoveAgent_Click(object sender, EventArgs e)
        {
            ListBoxMember.Items.Remove(ListBoxMember.SelectedItem);
        }

        private void BtnClearAgent_Click(object sender, EventArgs e)
        {
            ListBoxMember.Items.Clear();
        }
        
        private void ClearDlgUI()
        { 
            ComboPickupGroup.Text = "";
            ListBoxMember.Items.Clear();
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        private void GetMemberNameAll(ref ArrayList objList)
        {
            foreach (String sMemberName in ListBoxMember.Items)
            {
                objList.Add(sMemberName);
            }
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////////////////////////////

        private void AddUsers()
        {
            ComboMemberName.Items.Clear();

            ArrayList objListUsers = new ArrayList();
            cStoreUser.GetUserAll(ref objListUsers);

            if(objListUsers.Count <= 0) return;

            for (int nIndex = 0; nIndex < objListUsers.Count; nIndex++)
                ComboMemberName.Items.Add(objListUsers[nIndex]);

            if(ComboMemberName.SelectedIndex == -1 && ComboMemberName.Items.Count > 0)
                ComboMemberName.SelectedIndex = 0;
        }

        private void AddPickupGroups()
        {
            ComboPickupGroup.Items.Clear();

            ArrayList objList = new ArrayList();
            cStoreCallPickUp.GetGroupNameAll(ref objList);

            if (objList.Count <= 0)
                return;

            foreach (String sGroupName in objList)
            {
                ComboPickupGroup.Items.Add(sGroupName);
            }

            if(ComboPickupGroup.Items.Count > 0)
                ComboPickupGroup.SelectedIndex = 0;
        }

        public void OnSetActive()
        {
            AddUsers();
            
            AddPickupGroups();
            ShowPickupGroupDetails();
        }

        private void ComboPickupGroup_SelectedIndexChanged(object sender, EventArgs e)
        {
            ShowPickupGroupDetails();
        }

        private void ShowPickupGroupDetails()
        {
            String sGroupName = ComboPickupGroup.Text;
            
            if (sGroupName.Length == 0)
                return;
                      
            ArrayList objMemberList = new ArrayList();

            if (!cStoreCallPickUp.GetGroup(sGroupName, ref objMemberList))
                return;

            ListBoxMember.Items.Clear();

            foreach (String sMemberName in objMemberList)
                ListBoxMember.Items.Add(sMemberName);

        }
    }
}
