﻿using System;
using System.Collections;

namespace ServerSIP
{
    class cVaxRingGroup
    {
        public cVaxRingGroup()
        {

        }

        //////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////

        public void OnIncomingCall(int nSessionId, String sCallerName, String sCallerId, String sRingGroupName, ref Boolean bProcessed)
        {
            bProcessed = false;

            if (sRingGroupName.Length == 0)
                return;

            if (!cVaxServerSIP.mVaxSIP.AddCallSessionToRingGroup(sRingGroupName, sCallerName, sCallerId, nSessionId))
                return;

            bProcessed = true;
        }

        //////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////

        public static Boolean AddRingGroup(String sGroupName, int nProcessMode, int nProcessType, ArrayList objAgentList)
        {
            if (cVaxServerSIP.mVaxSIP.IsInitialized() == false || (sGroupName.Length == 0))
                return false;

            RemoveRingGroup(sGroupName);

            if (!cVaxServerSIP.mVaxSIP.AddRingGroup(sGroupName))
                return false;

            foreach (String sAgentName in objAgentList)
            {
                cVaxServerSIP.mVaxSIP.AddRingGroupAgent(sGroupName, sAgentName);
            }

            cVaxServerSIP.mVaxSIP.SetRingGroupProcessMode(sGroupName, nProcessMode, nProcessType);
            cStoreRingGroup.AddGroup(sGroupName, nProcessMode, nProcessType, objAgentList);

            return true;
        }

        public static void RemoveRingGroup(String sGroupName)
        {
            if (cVaxServerSIP.mVaxSIP.IsInitialized() == false || (sGroupName.Length == 0))
                return;

            cVaxServerSIP.mVaxSIP.RemoveRingGroup(sGroupName);
            cStoreRingGroup.RemoveGroup(sGroupName);
        }

        //////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////////

        public static void LoadRingGroup()
        {
            if (!cVaxServerSIP.mVaxSIP.IsInitialized())
                return;

            ArrayList objListRingGroup = new ArrayList();
            cStoreRingGroup.GetGroupNameAll(ref objListRingGroup);

            if (objListRingGroup.Count == 0)
                return;

            ArrayList objAgentList = new ArrayList();
            int nProcessMode = -1, nProcessType = -1;

            foreach (String sRingGroupName in objListRingGroup)
            {
                cStoreRingGroup.GetGroup(sRingGroupName, ref nProcessMode, ref nProcessType, ref objAgentList);
                AddRingGroup(sRingGroupName, nProcessMode, nProcessType, objAgentList);
            }
        }
    }
}
