﻿using System;
using System.Collections;

namespace ServerSIP
{
    class cVaxSettingDefault
    {
        /////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////

        public static Boolean LoadUserDefault()
        {
            if (cStoreUser.IsDataStored())
                return false;

            for (int nCount = 4000; nCount <= 4050; nCount++)
                cVaxUser.AddUser(nCount.ToString(), nCount.ToString(), "32014", false, cVaxServerCOM.VAX_AUDIO_TYPE_NORMAL, "", "", "");

            for (int nCount = 6000; nCount <= 6020; nCount++)
                cVaxUser.AddUser(nCount.ToString(), nCount.ToString(), "32014", false, cVaxServerCOM.VAX_AUDIO_TYPE_USER, "", "", "");

            for (int nCount = 8000; nCount <= 8020; nCount++)
                cVaxUser.AddUser(nCount.ToString(), nCount.ToString(), "32014", false, cVaxServerCOM.VAX_AUDIO_TYPE_ADMIN, "", "", "");

            return true;
        }

        public static Boolean LoadQueueDefault()
        {
            if (cStoreQueue.IsDataStored())
                return false;

            ArrayList objAgentList = new ArrayList() { "6000", "6001", "6002", "6003", "6004", "6005" };
            cVaxQueue.AddQueue("QueueTech", cVaxServerCOM.VAX_QUEUE_PROCESS_MODE_ROUND_ROBIN, cVaxServerCOM.VAX_QUEUE_PROCESS_TYPE_FREE, objAgentList, cVaxDefine.MUSIC_FILE_QUEUE, cVaxDefine.MUSIC_FILE_DIAL_TONE);

            objAgentList = new ArrayList() { "6010", "6011", "6012", "6013", "6014", "6015" };
            cVaxQueue.AddQueue("QueueSales", cVaxServerCOM.VAX_QUEUE_PROCESS_MODE_HUNT_RANDOM, cVaxServerCOM.VAX_QUEUE_PROCESS_TYPE_FREE, objAgentList, cVaxDefine.MUSIC_FILE_QUEUE, cVaxDefine.MUSIC_FILE_DIAL_TONE);
                        
            return true;
        }

        public static Boolean LoadRingGroupDefault()
        {
            if (cStoreRingGroup.IsDataStored())
                return false;
                        
            ArrayList objAgentList = new ArrayList() { "4000", "4001", "4002", "4003", "4004", "4005" };
            cVaxRingGroup.AddRingGroup("RingGroupTech", cVaxServerCOM.VAX_RING_GROUP_PROCESS_MODE_RING_ALL, cVaxServerCOM.VAX_RING_GROUP_PROCESS_TYPE_FREE, objAgentList);

            objAgentList = new ArrayList() { "4010", "4011", "4012", "4013", "4014", "4015" };
            cVaxRingGroup.AddRingGroup("RingGroupDesign", cVaxServerCOM.VAX_RING_GROUP_PROCESS_MODE_HUNT_RANDOM, cVaxServerCOM.VAX_RING_GROUP_PROCESS_TYPE_FREE, objAgentList);

            return true;
        }

        public static Boolean LoadCallPickUpGroupDefault()
        {
            if (cStoreCallPickUp.IsDataStored())
                return false;

            ArrayList objMemberList = new ArrayList() { "4000", "4001", "4002", "4003", "4004", "4005" };
            cVaxPickUpGroup.AddCallPickUpGroup("PickUpTech", objMemberList);

            objMemberList = new ArrayList() { "4010", "4011", "4012", "4013", "4014", "4015" };
            cVaxPickUpGroup.AddCallPickUpGroup("PickUpDesign", objMemberList);

            return true;
        }

        public static Boolean LoadLineDefault()
        {
            if (cStoreLine.IsDataStored())
                return false;

            cVaxLine.AddLine("LineServiceProviderTech", cVaxServerCOM.VAX_LINE_TYPE_UDP, "9090", "9090", "192.168.0.119", 5060, "32", false, "", false, "", "QueueTech", "");
            cVaxLine.AddLine("LineServiceProviderDesign", cVaxServerCOM.VAX_LINE_TYPE_UDP, "9092", "9092", "192.168.0.119", 5060, "32", false, "", false, "", "QueueSales", "");

            return true;
        }

        public static Boolean LoadRoomDefault()
        {
            if (cStoreRoom.IsDataStored())
                return false;

            cVaxRoom.AddRoom("RoomTech", "20021");
            cVaxRoom.AddRoom("RoomDesign", "20022");

            return true;
        }

    }
}
