﻿using System;
using System.Collections;

namespace ServerSIP
{
    class cStoreQueue
    {
        const String QUEUE_ROOT_PATH = "Queues\\";
               
        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public static Boolean AddQueue(String sQueueName, int nProcessMode, int nProcessType, ArrayList objAgentList, String sMusicFileName, String sDialToneFileName)
        {
            RemoveQueue(sQueueName);

            if(sQueueName.Length == 0)
                return false;

            String sKeyPath = QUEUE_ROOT_PATH + sQueueName;
            cStoreRegistry objStore = new cStoreRegistry();

            if (!objStore.SetTEXT(sKeyPath, "QueueName", sQueueName))
            {
                objStore.Close();
                return false;
            }

            cStoreQueue.AddQueueAgentNameAll(sQueueName, objAgentList);

            cStoreQueue.SetQueueProcessMode(sQueueName, nProcessMode, nProcessType);
            cStoreQueue.SetMediaFiles(sQueueName, sMusicFileName, sDialToneFileName);

            objStore.Close();
            return true;
        }
        
        public static void RemoveQueue(String sQueueName)
        {
            if(sQueueName.Length == 0)
                return;

            String sKeyPath = QUEUE_ROOT_PATH + sQueueName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.DeleteSubKey(sKeyPath);
            objStore.Close();
        }
           
        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public static void GetQueueNameAll(ref ArrayList objList)
        {
            objList.Clear();

            String sKeyPath = QUEUE_ROOT_PATH;
            cStoreRegistry objStore = new cStoreRegistry();
            
            objStore.EnumSubKeys(sKeyPath, ref objList);
            objStore.Close();
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public static void GetQueue(String sQueueName, ref int nProcessMode, ref int nProcessType, ref ArrayList objAgentList, ref String sMusicFileName, ref String sDialToneFileName)
        {
            cStoreQueue.GetQueueProcessMode(sQueueName, ref nProcessMode, ref nProcessType);
            cStoreQueue.GetQueueAgentNameAll(sQueueName, ref objAgentList);

            cStoreQueue.GetMediaFiles(sQueueName, ref sMusicFileName, ref sDialToneFileName);
        }

        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        private static Boolean SetMediaFiles(String sQueueName, String sMusicFileName, String sDialToneFileName)
        {
            String sPath = QUEUE_ROOT_PATH + sQueueName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.SetTEXT(sPath, "MusicFileName", sMusicFileName);
            objStore.SetTEXT(sPath, "DialToneFileName", sDialToneFileName);

            objStore.Close();
            return true;
        }

        private static void GetMediaFiles(String sQueueName, ref String sMusicFileName, ref String sDialToneFileName)
        {
            String sPath = QUEUE_ROOT_PATH + sQueueName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.GetTEXT(sPath, "MusicFileName", ref sMusicFileName, cVaxDefine.MUSIC_FILE_QUEUE);
            objStore.GetTEXT(sPath, "DialToneFileName", ref sDialToneFileName, cVaxDefine.MUSIC_FILE_DIAL_TONE);

            objStore.Close();
        }
                        
        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        private static Boolean SetQueueProcessMode(String sQueueName, int nProcessMode, int nProcessType)
        {
            if(sQueueName.Length == 0)
                return false;

            String sKeyPath = QUEUE_ROOT_PATH + sQueueName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.SetINT(sKeyPath, "ProcessMode", nProcessMode);
            objStore.SetINT(sKeyPath, "ProcessType", nProcessType);

            objStore.Close();
            return true;
        }

        private static void GetQueueProcessMode(String sQueueName, ref int nProcessMode, ref int nProcessType)
        {
            String sKeyPath = QUEUE_ROOT_PATH + sQueueName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.GetINT(sKeyPath, "ProcessMode", ref nProcessMode, cVaxServerCOM.VAX_QUEUE_PROCESS_MODE_ROUND_ROBIN);
            objStore.GetINT(sKeyPath, "ProcessType", ref nProcessType, cVaxServerCOM.VAX_QUEUE_PROCESS_TYPE_FREE);

            objStore.Close();
        }
        
        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        private static void AddQueueAgentNameAll(String sQueueName, ArrayList objList)
        {
            if(sQueueName.Length == 0)
                return;

            cStoreRegistry objStore = new cStoreRegistry();
   
            foreach (String sUserName in objList)
            {
                String sKeyPath = QUEUE_ROOT_PATH + sQueueName + "\\" + sUserName;
                objStore.SetTEXT(sKeyPath, "UserName", sUserName);
            }

            objStore.Close();
        }
                
        public static void GetQueueAgentNameAll(String sQueueName, ref ArrayList objList)
        {
            objList.Clear();

            String sKeyPath = QUEUE_ROOT_PATH + sQueueName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.EnumSubKeys(sKeyPath, ref objList);
            objStore.Close();
        }
                        
        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public static Boolean IsDataStored()
        {
            cStoreRegistry objStore = new cStoreRegistry();
            Boolean bResult = objStore.IsKeyExist(QUEUE_ROOT_PATH);

            objStore.Close();
            return bResult;
        }

    }
}
