﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Speech.Synthesis;
using System.Speech.AudioFormat;
using System.IO;
using Microsoft;

namespace AutoDialer
{
    public class cTextToSpeech
    {

        public cTextToSpeech()
        {
            
        }

        public void GenSpeech(String sText, ref Byte[] aDataPCM, ref long nDataSize)
        {
            SpeechSynthesizer hSynthesizer = new SpeechSynthesizer();

            PromptBuilder hbuilder = new PromptBuilder();
            PromptStyle hStyle = new PromptStyle();

            hStyle.Emphasis = PromptEmphasis.None;
            hStyle.Rate = PromptRate.Fast;
            hStyle.Volume = PromptVolume.ExtraLoud;

            hbuilder.StartStyle(hStyle);
            hbuilder.StartParagraph();
            hbuilder.StartVoice(VoiceGender.Male, VoiceAge.Teen, 2);
            hbuilder.StartSentence();
            hbuilder.AppendText(sText);
            hbuilder.EndSentence();
            hbuilder.EndVoice();
            hbuilder.EndParagraph();
            hbuilder.EndStyle();

            SpeechAudioFormatInfo hSynthFormat = new SpeechAudioFormatInfo(8000, AudioBitsPerSample.Sixteen, AudioChannel.Mono);
            MemoryStream hStreamMem = new MemoryStream();

            hSynthesizer.SetOutputToAudioStream(hStreamMem, hSynthFormat);
            hSynthesizer.Speak(hbuilder);
            hSynthesizer.SetOutputToNull();

            hStreamMem.Position = 0;
            nDataSize = hStreamMem.Length;

            aDataPCM = new Byte[nDataSize];
            Array.Copy(hStreamMem.ToArray(), aDataPCM, nDataSize);
        }
    }
}
