﻿using System;
using System.Collections;

namespace BasicIVR
{
    class cStoreLine
    {
        const string LINE_ROOT_PATH = "Lines\\";

        //////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////

        public static bool AddLine(string sLineName, int nLineType, String sDisplayName, String sUserName, String sAuthUser, String sAuthPwd, String sDomainRealm, String sServerAddr, int nServerPort)
        {
            if (sLineName.Length == 0)
                return false;

            string sKeyPath = LINE_ROOT_PATH + sLineName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.SetTEXT(sKeyPath, "LineName", sLineName);
            objStore.SetINT(sKeyPath, "LineType", nLineType);

            objStore.SetTEXT(sKeyPath, "DisplayName", sDisplayName);
            objStore.SetTEXT(sKeyPath, "UserName", sUserName);

            objStore.SetTEXT(sKeyPath, "AuthUser", sAuthUser);
            objStore.SetTEXT(sKeyPath, "AuthPwd", sAuthPwd);

            objStore.SetTEXT(sKeyPath, "DomainRealm", sDomainRealm);

            objStore.SetTEXT(sKeyPath, "ServerAddr", sServerAddr);
            objStore.SetINT(sKeyPath, "ServerPort", nServerPort);
            
            objStore.Close();
            return true;
        }

        public static void RemoveLine(string sLineName)
        {
            if (sLineName.Length == 0)
                return;

            string sKeyPath = LINE_ROOT_PATH + sLineName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.DeleteSubKey(sKeyPath);
            objStore.Close();
        }

      //////////////////////////////////////////////////////////////////////////////
      //////////////////////////////////////////////////////////////////////////////

        public static bool GetLine(String sLineName, ref int nLineType, ref String sDisplayName, ref String sUserName, ref String sAuthUser, ref String sAuthPwd, ref String sDomainRealm, ref String sServerAddr, ref int nServerPort)
        {
            if (sLineName.Length == 0)
                return false;

            string sKeyPath = LINE_ROOT_PATH + sLineName;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.GetINT(sKeyPath, "LineType", ref nLineType, cVaxServerCOM.VAX_LINE_TYPE_UDP);

            objStore.GetTEXT(sKeyPath, "DisplayName", ref sDisplayName, "");
            objStore.GetTEXT(sKeyPath, "UserName", ref sUserName, "");

            objStore.GetTEXT(sKeyPath, "AuthUser", ref sAuthUser, "");
            objStore.GetTEXT(sKeyPath, "AuthPwd", ref sAuthPwd, "");

            objStore.GetTEXT(sKeyPath, "DomainRealm", ref sDomainRealm, "");

            objStore.GetTEXT(sKeyPath, "ServerAddr", ref sServerAddr, "");
            objStore.GetINT(sKeyPath, "ServerPort", ref nServerPort, cVaxServerCOM.SIP_DEFAULT_PORT);
            
            objStore.Close();
            
            return true;
        }

        public static void GetLineNameAll(ref ArrayList objList)
        {
            objList.Clear();

            string sKeyPath = LINE_ROOT_PATH;
            cStoreRegistry objStore = new cStoreRegistry();

            objStore.EnumSubKeys(sKeyPath, ref objList);
            objStore.Close();
        }
                
        /////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////

        public static bool IsDataStored()
        {
            cStoreRegistry objStore = new cStoreRegistry();
            bool bResult = objStore.IsKeyExist(LINE_ROOT_PATH);

            objStore.Close();
            return bResult;
        }
    }
}
