﻿Imports System

Namespace ServerSIP

    Class cVaxCallSession

        Shared m_objRouteCallSIP As cVaxCallSessionRoute = Nothing

        Private m_objAccessPCM As cVaxAccessAudioPCM
        Private m_objDetectVAD As cVaxDetectAudioVAD

        Private m_objVaxCall As cVaxCall
        Private m_objVaxTransfer As cVaxTransfer

        Private m_objVaxDTMF As cVaxDTMF
        Private m_objVaxAMD As cVaxDetectAMD
        Private m_objVaxRoom As cVaxRoom

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Sub New()

            If cVaxCallSession.m_objRouteCallSIP Is Nothing Then
                cVaxCallSession.m_objRouteCallSIP = New cVaxCallSessionRoute()
            End If

            m_objAccessPCM = New cVaxAccessAudioPCM()
            m_objDetectVAD = New cVaxDetectAudioVAD()

            m_objVaxCall = New cVaxCall()
            m_objVaxTransfer = New cVaxTransfer()

            m_objVaxDTMF = New cVaxDTMF()
            m_objVaxAMD = New cVaxDetectAMD()
            m_objVaxRoom = New cVaxRoom()

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        Public Sub OnCallSessionClosed(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal nReasonCode As Integer)
            m_objAccessPCM.OnCallSessionClosed(nSessionId)
            m_objDetectVAD.OnCallSessionClosed(nSessionId)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub AddUserRoute(ByVal sUserName As String, ByVal sUserPrefix As String, ByVal sDialPrefix As String, ByVal sToPeerName As String)
            cVaxCallSession.m_objRouteCallSIP.AddUserRoute(sUserName, sUserPrefix, sDialPrefix, sToPeerName)
        End Sub

        Public Shared Sub RemoveUserRoute(ByVal sUserName As String)
            cVaxCallSession.m_objRouteCallSIP.RemoveUserRoute(sUserName)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub AddLineRoute(ByVal sLineName As String, ByVal sToPeerName As String, ByVal bRejected As Boolean, ByVal sRoomName As String)
            cVaxCallSession.m_objRouteCallSIP.AddLineRoute(sLineName, sToPeerName, bRejected, sRoomName)
        End Sub

        Public Shared Sub RemoveLineRoute(ByVal sLineName As String)
            cVaxCallSession.m_objRouteCallSIP.RemoveLineRoute(sLineName)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Shared Sub ResetAll()
            cVaxCallSession.m_objRouteCallSIP = New cVaxCallSessionRoute()
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Sub GetFromPeerRouteInfo(ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sDialNo As String, ByRef sDialToNo As String, ByRef sToPeerName As String, ByRef bRejected As Boolean, ByRef sRoomName As String)

            If nFromPeerType = cVaxServerCOM.VAX_PEER_TYPE_USER Then
                cVaxCallSession.m_objRouteCallSIP.GetUserRouteInfo(sFromPeerName, sDialNo, sDialToNo, sToPeerName)
                Return
            End If

            cVaxCallSession.m_objRouteCallSIP.GetLineRouteInfo(sFromPeerName, sDialNo, sDialToNo, sToPeerName, bRejected, sRoomName)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sUserAgentName As String, ByVal sFromIP As String, ByVal nFromPort As Integer)

            Dim sToPeerName As String = "", sDialToNo As String = ""
            Dim sRoomName As String = ""
            Dim bRejected As Boolean = False

            GetFromPeerRouteInfo(nFromPeerType, sFromPeerName, sDialNo, sDialToNo, sToPeerName, bRejected, sRoomName)

            If bRejected Then
                cVaxServerSIP.mVaxSIP.RejectCallSession(nSessionId, 404, "Not Found")
                Return
            End If

            OnProcessCall(nSessionId, sCallerName, sCallerId, sDialToNo, nFromPeerType, sFromPeerName, sUserAgentName, sFromIP, nFromPort, sToPeerName, sRoomName)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Private Sub OnProcessCall(ByVal nSessionId As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String, ByVal nFromPeerType As Integer, ByVal sFromPeerName As String, ByVal sUserAgentName As String, ByVal sFromIP As String, ByVal nFromPort As Integer, ByVal sToPeerName As String, ByVal sRoomName As String)

            Dim bProcessed As Boolean = False

            m_objVaxRoom.OnIncomingCall(nSessionId, sRoomName, bProcessed)
            If bProcessed Then Return

            m_objVaxCall.OnIncomingCall(nSessionId, sCallerName, sCallerId, sDialNo, nFromPeerType, sFromPeerName, sToPeerName, bProcessed)

        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Sub OnCallSessionTransferBlind(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)
            m_objVaxTransfer.OnCallSessionTransferBlind(nTransfererSessionId, nTransfererChannelId, sTransferer, sTransferee, sTransferTo)
        End Sub

        Public Sub OnCallSessionTransferConsult(ByVal nTransfererSessionId As Integer, ByVal nTransfererChannelId As Integer, ByVal nTransferToSessionId As Integer, ByVal nTransferToChannelId As Integer, ByVal sTransferer As String, ByVal sTransferee As String, ByVal sTransferTo As String)
            m_objVaxTransfer.OnCallSessionTransferConsult(nTransfererSessionId, nTransfererChannelId, nTransferToSessionId, nTransferToChannelId, sTransferer, sTransferee, sTransferTo)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Sub OnDetectedDigitDTMF(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal sDigitDTMF As String)
            m_objVaxDTMF.OnDetectedDigitDTMF(nSessionId, nChannelId, sDigitDTMF)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Sub OnCallSessionDetectedAMD(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal bIsHuman As Boolean)
            m_objVaxAMD.OnCallSessionDetectedAMD(nSessionId, nChannelId, bIsHuman)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        Public Sub OnCallSessionAccessAudioPCM(nSessionId As Integer, nAccessType As Integer, aDataPCM As Byte(), nSizePCM As Integer)
            m_objAccessPCM.OnCallSessionAccessAudioPCM(nSessionId, nAccessType, aDataPCM, nSizePCM)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        Public Sub OnCallSessionConnected(ByVal nSessionId As Integer)
            m_objAccessPCM.OnCallSessionConnected(nSessionId)
            m_objDetectVAD.OnCallSessionConnected(nSessionId)
        End Sub

        '////////////////////////////////////////////////////////////////////////////////////////////////////////
        '////////////////////////////////////////////////////////////////////////////////////////////////////////

        Public Sub OnCallSessionMediaDetectStartedVAD(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
            m_objDetectVAD.OnCallSessionMediaDetectStartedVAD(nSessionId, nChannelId)
        End Sub

        Public Sub OnCallSessionMediaDetectCompletedVAD(ByVal nSessionId As Integer, ByVal nChannelId As Integer, ByVal aDataPCM As Byte(), ByVal nSizePCM As Integer, ByVal nTypePCM As Integer)
            m_objDetectVAD.OnCallSessionMediaDetectCompletedVAD(nSessionId, nChannelId, aDataPCM, nSizePCM, nTypePCM)
        End Sub

        Public Sub OnCallSessionMediaDetectExpiredVAD(ByVal nSessionId As Integer, ByVal nChannelId As Integer)
            m_objDetectVAD.OnCallSessionMediaDetectExpiredVAD(nSessionId, nChannelId)
        End Sub

    End Class

End Namespace
